using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Threading;
using System.Data;
using System.Reflection;
using System.IO;

using Microsoft.DirectX.DirectSound;

using DarkStrideToolbox;


namespace DSGobEditor
{
	public class frmMain : System.Windows.Forms.Form
	{
		#region Properties
		private const string m_cROOTKEY = "GOB File";

		private string m_sTableSelected = "";
		private DSGobFile m_oGob = new DSGobFile();
		private string m_sGOBLoadedFrom = "";
		private string m_sPathLastLoadedFrom = "";

		private bool m_bChangingTableType = false;
		private bool m_bChangingBorderFillType = false;
		private bool m_bRefreshingButtons = false;

		private DateTime m_dtLastGridClick = DateTime.MinValue;
		#endregion

		#region Windows Init & System Functions
		private System.Windows.Forms.MenuItem mnuFile_Exit;
		private System.Windows.Forms.MenuItem mnuActions;
		private System.Windows.Forms.MenuItem mnuActions_AddTable;
		private System.Windows.Forms.MenuItem mnuFile_SaveAs;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.ImageList imgTreeIcons;
		private System.Windows.Forms.MenuItem mnuFile_Open;
		private System.Windows.Forms.MenuItem mnuFile_Save;
		private System.Windows.Forms.MenuItem mnuFile;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.TreeView treTables;
		private System.Windows.Forms.Button cmdAddTable;
		private System.Windows.Forms.Button cmdEditColumn;
		private System.Windows.Forms.Button cmdAddColumn;
		private System.Windows.Forms.Button cmdDeleteTable;
		private System.Windows.Forms.Button cmdAddFoler;
		private System.Windows.Forms.Button cmdAddFile;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button cmdExit;
		private System.Windows.Forms.TextBox txtTableName;
		private System.Windows.Forms.ComboBox cboTableType;
		private System.Windows.Forms.Label lblFileType;
		private System.Windows.Forms.Button cmdUpdateTableFromFile;
		private System.Windows.Forms.Button cmdSaveTableToFile;
		private System.Windows.Forms.Panel pnlBorder;
		private System.Windows.Forms.ComboBox cboBorderFillType;
		private System.Windows.Forms.TextBox txtBoder_Left;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.TextBox txtBoder_Top;
		private System.Windows.Forms.TextBox txtBoder_Bottom;
		private System.Windows.Forms.TextBox txtBoder_Right;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.ComboBox cboBorder_UpperLeft;
		private System.Windows.Forms.ComboBox cboBorder_MiddleLeft;
		private System.Windows.Forms.ComboBox cboBorder_LowerLeft;
		private System.Windows.Forms.ComboBox cboBorder_UpperMiddle;
		private System.Windows.Forms.ComboBox cboBorder_UpperRight;
		private System.Windows.Forms.ComboBox cboBorder_MiddleRight;
		private System.Windows.Forms.ComboBox cboBorder_LowerRight;
		private System.Windows.Forms.ComboBox cboBorder_LowerMiddle;
		private System.Windows.Forms.CheckBox chkBorderFill_Stretch;
		private System.Windows.Forms.Label lblBorderFillColor;
		private System.Windows.Forms.ComboBox cboBorderFill_Graphic;
		private System.Windows.Forms.Label lblBorderFillGraphic;
		private System.Windows.Forms.DataGrid grdTable;
		private System.Windows.Forms.ColorDialog dlgColor;
		private System.Windows.Forms.TextBox txtBorderFill_Color;
		private System.Windows.Forms.Button cmdBorderFill_PickColor;
		private System.Windows.Forms.Panel pnlSound;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.NumericUpDown nmrMaxSounds;
		private System.Windows.Forms.CheckBox chkMaxSoundBuffers;
		private System.Windows.Forms.Button cmdPlaySound;
		private System.Windows.Forms.Panel pnlPicture;
		private System.Windows.Forms.Button cmdPicTransparencyColor;
		private System.Windows.Forms.TextBox txtPicTransparencyColor;
		private System.Windows.Forms.Label lblTransparentColor;
		private System.Windows.Forms.Label lblPicSize;
		private System.Windows.Forms.TextBox txtRealPic_Bottom;
		private System.Windows.Forms.TextBox txtRealPic_Top;
		private System.Windows.Forms.TextBox txtRealPic_Right;
		private System.Windows.Forms.Label lblRealPic;
		private System.Windows.Forms.TextBox txtRealPic_Left;
		private System.Windows.Forms.TextBox txtSoundSecondsBetweenPlays;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Panel pnlSpriteSheet;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Splitter splitter2;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Panel pnlSpriteSheet_Misc2;
		private System.Windows.Forms.Panel pnlSpriteSheet_Misc1;
		private System.Windows.Forms.TextBox txtSpriteSheetTransparencyColor;
		private System.Windows.Forms.Button cmdSpriteSheetPickColor;
		private System.Windows.Forms.DataGrid grdSpriteSheet;
		private System.Windows.Forms.Label lblSpriteSheetPicSize;
		private System.Windows.Forms.Button cmdRefreshSpriteSheet;
		private System.Windows.Forms.Panel pnlSpriteSheet_Misc3;
		private System.Windows.Forms.PictureBox picSpriteSheetPreview;
		private System.Windows.Forms.Panel pnlGraphic_Misc1;
		private System.Windows.Forms.PictureBox picPreview;
		private System.Windows.Forms.ListBox lstErrors;
		private System.Windows.Forms.MenuItem mnuTree;
		private System.Windows.Forms.MenuItem mnuTree_CollapseAll;
		private System.Windows.Forms.MenuItem mnuTree_ExpandAll;


		private System.ComponentModel.IContainer components;

		public frmMain()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmMain));
			this.mnuFile_Exit = new System.Windows.Forms.MenuItem();
			this.mnuActions = new System.Windows.Forms.MenuItem();
			this.mnuActions_AddTable = new System.Windows.Forms.MenuItem();
			this.mnuFile_SaveAs = new System.Windows.Forms.MenuItem();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.imgTreeIcons = new System.Windows.Forms.ImageList(this.components);
			this.mnuFile_Open = new System.Windows.Forms.MenuItem();
			this.mnuFile_Save = new System.Windows.Forms.MenuItem();
			this.mnuFile = new System.Windows.Forms.MenuItem();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.mnuTree = new System.Windows.Forms.MenuItem();
			this.mnuTree_CollapseAll = new System.Windows.Forms.MenuItem();
			this.mnuTree_ExpandAll = new System.Windows.Forms.MenuItem();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.treTables = new System.Windows.Forms.TreeView();
			this.cmdAddTable = new System.Windows.Forms.Button();
			this.cmdEditColumn = new System.Windows.Forms.Button();
			this.cmdAddColumn = new System.Windows.Forms.Button();
			this.cmdDeleteTable = new System.Windows.Forms.Button();
			this.cmdAddFoler = new System.Windows.Forms.Button();
			this.cmdAddFile = new System.Windows.Forms.Button();
			this.panel1 = new System.Windows.Forms.Panel();
			this.cmdUpdateTableFromFile = new System.Windows.Forms.Button();
			this.cmdSaveTableToFile = new System.Windows.Forms.Button();
			this.panel2 = new System.Windows.Forms.Panel();
			this.pnlSound = new System.Windows.Forms.Panel();
			this.label3 = new System.Windows.Forms.Label();
			this.txtSoundSecondsBetweenPlays = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.nmrMaxSounds = new System.Windows.Forms.NumericUpDown();
			this.chkMaxSoundBuffers = new System.Windows.Forms.CheckBox();
			this.cmdPlaySound = new System.Windows.Forms.Button();
			this.lstErrors = new System.Windows.Forms.ListBox();
			this.lblFileType = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.cmdExit = new System.Windows.Forms.Button();
			this.txtTableName = new System.Windows.Forms.TextBox();
			this.cboTableType = new System.Windows.Forms.ComboBox();
			this.pnlSpriteSheet = new System.Windows.Forms.Panel();
			this.pnlSpriteSheet_Misc1 = new System.Windows.Forms.Panel();
			this.grdSpriteSheet = new System.Windows.Forms.DataGrid();
			this.splitter2 = new System.Windows.Forms.Splitter();
			this.pnlSpriteSheet_Misc2 = new System.Windows.Forms.Panel();
			this.pnlSpriteSheet_Misc3 = new System.Windows.Forms.Panel();
			this.picSpriteSheetPreview = new System.Windows.Forms.PictureBox();
			this.cmdRefreshSpriteSheet = new System.Windows.Forms.Button();
			this.txtSpriteSheetTransparencyColor = new System.Windows.Forms.TextBox();
			this.label6 = new System.Windows.Forms.Label();
			this.lblSpriteSheetPicSize = new System.Windows.Forms.Label();
			this.cmdSpriteSheetPickColor = new System.Windows.Forms.Button();
			this.grdTable = new System.Windows.Forms.DataGrid();
			this.pnlBorder = new System.Windows.Forms.Panel();
			this.cboBorder_LowerMiddle = new System.Windows.Forms.ComboBox();
			this.cboBorderFillType = new System.Windows.Forms.ComboBox();
			this.cboBorder_LowerRight = new System.Windows.Forms.ComboBox();
			this.cboBorder_MiddleRight = new System.Windows.Forms.ComboBox();
			this.cboBorder_UpperRight = new System.Windows.Forms.ComboBox();
			this.cboBorder_UpperMiddle = new System.Windows.Forms.ComboBox();
			this.cboBorder_LowerLeft = new System.Windows.Forms.ComboBox();
			this.cboBorder_MiddleLeft = new System.Windows.Forms.ComboBox();
			this.cboBorder_UpperLeft = new System.Windows.Forms.ComboBox();
			this.label5 = new System.Windows.Forms.Label();
			this.txtBoder_Right = new System.Windows.Forms.TextBox();
			this.txtBoder_Bottom = new System.Windows.Forms.TextBox();
			this.txtBoder_Top = new System.Windows.Forms.TextBox();
			this.label4 = new System.Windows.Forms.Label();
			this.txtBoder_Left = new System.Windows.Forms.TextBox();
			this.lblBorderFillColor = new System.Windows.Forms.Label();
			this.lblBorderFillGraphic = new System.Windows.Forms.Label();
			this.chkBorderFill_Stretch = new System.Windows.Forms.CheckBox();
			this.cmdBorderFill_PickColor = new System.Windows.Forms.Button();
			this.txtBorderFill_Color = new System.Windows.Forms.TextBox();
			this.cboBorderFill_Graphic = new System.Windows.Forms.ComboBox();
			this.pnlPicture = new System.Windows.Forms.Panel();
			this.pnlGraphic_Misc1 = new System.Windows.Forms.Panel();
			this.picPreview = new System.Windows.Forms.PictureBox();
			this.cmdPicTransparencyColor = new System.Windows.Forms.Button();
			this.txtPicTransparencyColor = new System.Windows.Forms.TextBox();
			this.lblTransparentColor = new System.Windows.Forms.Label();
			this.lblPicSize = new System.Windows.Forms.Label();
			this.txtRealPic_Bottom = new System.Windows.Forms.TextBox();
			this.txtRealPic_Top = new System.Windows.Forms.TextBox();
			this.txtRealPic_Right = new System.Windows.Forms.TextBox();
			this.lblRealPic = new System.Windows.Forms.Label();
			this.txtRealPic_Left = new System.Windows.Forms.TextBox();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.button1 = new System.Windows.Forms.Button();
			this.dlgColor = new System.Windows.Forms.ColorDialog();
			this.panel1.SuspendLayout();
			this.panel2.SuspendLayout();
			this.pnlSound.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.nmrMaxSounds)).BeginInit();
			this.pnlSpriteSheet.SuspendLayout();
			this.pnlSpriteSheet_Misc1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.grdSpriteSheet)).BeginInit();
			this.pnlSpriteSheet_Misc2.SuspendLayout();
			this.pnlSpriteSheet_Misc3.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.grdTable)).BeginInit();
			this.pnlBorder.SuspendLayout();
			this.pnlPicture.SuspendLayout();
			this.pnlGraphic_Misc1.SuspendLayout();
			this.SuspendLayout();
			// 
			// mnuFile_Exit
			// 
			this.mnuFile_Exit.Index = 4;
			this.mnuFile_Exit.Text = "E&xit";
			this.mnuFile_Exit.Click += new System.EventHandler(this.cmdExit_Click);
			// 
			// mnuActions
			// 
			this.mnuActions.Index = 1;
			this.mnuActions.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					   this.mnuActions_AddTable});
			this.mnuActions.Text = "Actions";
			// 
			// mnuActions_AddTable
			// 
			this.mnuActions_AddTable.Index = 0;
			this.mnuActions_AddTable.Text = "Add Table";
			// 
			// mnuFile_SaveAs
			// 
			this.mnuFile_SaveAs.Index = 2;
			this.mnuFile_SaveAs.Text = "Save &As...";
			this.mnuFile_SaveAs.Click += new System.EventHandler(this.mnuFile_SaveAs_Click);
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 3;
			this.menuItem1.Text = "-";
			// 
			// imgTreeIcons
			// 
			this.imgTreeIcons.ImageSize = new System.Drawing.Size(16, 16);
			this.imgTreeIcons.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imgTreeIcons.ImageStream")));
			this.imgTreeIcons.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// mnuFile_Open
			// 
			this.mnuFile_Open.Index = 0;
			this.mnuFile_Open.Text = "&Open...";
			this.mnuFile_Open.Click += new System.EventHandler(this.mnuFile_Open_Click);
			// 
			// mnuFile_Save
			// 
			this.mnuFile_Save.Index = 1;
			this.mnuFile_Save.Text = "&Save...";
			this.mnuFile_Save.Click += new System.EventHandler(this.mnuFile_Save_Click);
			// 
			// mnuFile
			// 
			this.mnuFile.Index = 0;
			this.mnuFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.mnuFile_Open,
																					this.mnuFile_Save,
																					this.mnuFile_SaveAs,
																					this.menuItem1,
																					this.mnuFile_Exit});
			this.mnuFile.Text = "File";
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.mnuFile,
																					  this.mnuActions,
																					  this.mnuTree});
			this.mainMenu1.RightToLeft = System.Windows.Forms.RightToLeft.No;
			// 
			// mnuTree
			// 
			this.mnuTree.Index = 2;
			this.mnuTree.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.mnuTree_CollapseAll,
																					this.mnuTree_ExpandAll});
			this.mnuTree.Text = "Tree";
			// 
			// mnuTree_CollapseAll
			// 
			this.mnuTree_CollapseAll.Index = 0;
			this.mnuTree_CollapseAll.Text = "Collapse All";
			this.mnuTree_CollapseAll.Click += new System.EventHandler(this.mnuTree_CollapseAll_Click);
			// 
			// mnuTree_ExpandAll
			// 
			this.mnuTree_ExpandAll.Index = 1;
			this.mnuTree_ExpandAll.Text = "Expand All";
			this.mnuTree_ExpandAll.Click += new System.EventHandler(this.mnuTree_ExpandAll_Click);
			// 
			// splitter1
			// 
			this.splitter1.BackColor = System.Drawing.SystemColors.Control;
			this.splitter1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.splitter1.Location = new System.Drawing.Point(256, 0);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(6, 489);
			this.splitter1.TabIndex = 34;
			this.splitter1.TabStop = false;
			// 
			// treTables
			// 
			this.treTables.AllowDrop = true;
			this.treTables.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.treTables.FullRowSelect = true;
			this.treTables.HideSelection = false;
			this.treTables.ImageList = this.imgTreeIcons;
			this.treTables.Location = new System.Drawing.Point(8, 8);
			this.treTables.Name = "treTables";
			this.treTables.Size = new System.Drawing.Size(240, 316);
			this.treTables.TabIndex = 16;
			this.treTables.KeyDown += new System.Windows.Forms.KeyEventHandler(this.treTables_KeyDown);
			this.treTables.DragOver += new System.Windows.Forms.DragEventHandler(this.treTables_DragOver);
			this.treTables.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.treTables_AfterSelect);
			this.treTables.DragEnter += new System.Windows.Forms.DragEventHandler(this.treTables_DragEnter);
			this.treTables.ItemDrag += new System.Windows.Forms.ItemDragEventHandler(this.treTables_ItemDrag);
			this.treTables.DragDrop += new System.Windows.Forms.DragEventHandler(this.treTables_DragDrop);
			// 
			// cmdAddTable
			// 
			this.cmdAddTable.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.cmdAddTable.Location = new System.Drawing.Point(8, 380);
			this.cmdAddTable.Name = "cmdAddTable";
			this.cmdAddTable.Size = new System.Drawing.Size(72, 24);
			this.cmdAddTable.TabIndex = 18;
			this.cmdAddTable.Text = "Add Table";
			this.cmdAddTable.Click += new System.EventHandler(this.cmdAddTable_Click);
			// 
			// cmdEditColumn
			// 
			this.cmdEditColumn.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.cmdEditColumn.Enabled = false;
			this.cmdEditColumn.Location = new System.Drawing.Point(88, 356);
			this.cmdEditColumn.Name = "cmdEditColumn";
			this.cmdEditColumn.Size = new System.Drawing.Size(88, 24);
			this.cmdEditColumn.TabIndex = 27;
			this.cmdEditColumn.Text = "Edit Column";
			// 
			// cmdAddColumn
			// 
			this.cmdAddColumn.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.cmdAddColumn.Enabled = false;
			this.cmdAddColumn.Location = new System.Drawing.Point(88, 380);
			this.cmdAddColumn.Name = "cmdAddColumn";
			this.cmdAddColumn.Size = new System.Drawing.Size(88, 24);
			this.cmdAddColumn.TabIndex = 19;
			this.cmdAddColumn.Text = "Add Column";
			this.cmdAddColumn.Click += new System.EventHandler(this.cmdAddColumn_Click);
			// 
			// cmdDeleteTable
			// 
			this.cmdDeleteTable.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.cmdDeleteTable.Enabled = false;
			this.cmdDeleteTable.Location = new System.Drawing.Point(8, 412);
			this.cmdDeleteTable.Name = "cmdDeleteTable";
			this.cmdDeleteTable.Size = new System.Drawing.Size(168, 24);
			this.cmdDeleteTable.TabIndex = 26;
			this.cmdDeleteTable.Text = "Delete Table";
			this.cmdDeleteTable.Click += new System.EventHandler(this.cmdDeleteTable_Click);
			// 
			// cmdAddFoler
			// 
			this.cmdAddFoler.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.cmdAddFoler.Location = new System.Drawing.Point(8, 332);
			this.cmdAddFoler.Name = "cmdAddFoler";
			this.cmdAddFoler.Size = new System.Drawing.Size(72, 24);
			this.cmdAddFoler.TabIndex = 28;
			this.cmdAddFoler.Text = "Add Folder";
			this.cmdAddFoler.Click += new System.EventHandler(this.cmdAddFolder_Click);
			// 
			// cmdAddFile
			// 
			this.cmdAddFile.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.cmdAddFile.Location = new System.Drawing.Point(8, 356);
			this.cmdAddFile.Name = "cmdAddFile";
			this.cmdAddFile.Size = new System.Drawing.Size(72, 24);
			this.cmdAddFile.TabIndex = 22;
			this.cmdAddFile.Text = "Add File";
			this.cmdAddFile.Click += new System.EventHandler(this.cmdAddFile_Click);
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.cmdUpdateTableFromFile);
			this.panel1.Controls.Add(this.cmdSaveTableToFile);
			this.panel1.Controls.Add(this.cmdAddColumn);
			this.panel1.Controls.Add(this.cmdAddTable);
			this.panel1.Controls.Add(this.treTables);
			this.panel1.Controls.Add(this.cmdEditColumn);
			this.panel1.Controls.Add(this.cmdDeleteTable);
			this.panel1.Controls.Add(this.cmdAddFoler);
			this.panel1.Controls.Add(this.cmdAddFile);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Left;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(256, 489);
			this.panel1.TabIndex = 0;
			// 
			// cmdUpdateTableFromFile
			// 
			this.cmdUpdateTableFromFile.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.cmdUpdateTableFromFile.Enabled = false;
			this.cmdUpdateTableFromFile.Location = new System.Drawing.Point(8, 436);
			this.cmdUpdateTableFromFile.Name = "cmdUpdateTableFromFile";
			this.cmdUpdateTableFromFile.Size = new System.Drawing.Size(168, 24);
			this.cmdUpdateTableFromFile.TabIndex = 44;
			this.cmdUpdateTableFromFile.Text = "Update Table From File...";
			this.cmdUpdateTableFromFile.Click += new System.EventHandler(this.cmdUpdateTableFromFile_Click);
			// 
			// cmdSaveTableToFile
			// 
			this.cmdSaveTableToFile.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.cmdSaveTableToFile.Enabled = false;
			this.cmdSaveTableToFile.Location = new System.Drawing.Point(8, 460);
			this.cmdSaveTableToFile.Name = "cmdSaveTableToFile";
			this.cmdSaveTableToFile.Size = new System.Drawing.Size(168, 24);
			this.cmdSaveTableToFile.TabIndex = 43;
			this.cmdSaveTableToFile.Text = "Export Table To File...";
			this.cmdSaveTableToFile.Click += new System.EventHandler(this.cmdSaveTableToFile_Click);
			// 
			// panel2
			// 
			this.panel2.Controls.Add(this.lstErrors);
			this.panel2.Controls.Add(this.lblFileType);
			this.panel2.Controls.Add(this.label1);
			this.panel2.Controls.Add(this.cmdExit);
			this.panel2.Controls.Add(this.txtTableName);
			this.panel2.Controls.Add(this.cboTableType);
			this.panel2.Controls.Add(this.pnlSpriteSheet);
			this.panel2.Controls.Add(this.grdTable);
			this.panel2.Controls.Add(this.pnlBorder);
			this.panel2.Controls.Add(this.pnlPicture);
			this.panel2.Controls.Add(this.pnlSound);
			this.panel2.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel2.Location = new System.Drawing.Point(262, 0);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(498, 489);
			this.panel2.TabIndex = 35;
			// 
			// pnlSound
			// 
			this.pnlSound.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.pnlSound.Controls.Add(this.label3);
			this.pnlSound.Controls.Add(this.txtSoundSecondsBetweenPlays);
			this.pnlSound.Controls.Add(this.label2);
			this.pnlSound.Controls.Add(this.nmrMaxSounds);
			this.pnlSound.Controls.Add(this.chkMaxSoundBuffers);
			this.pnlSound.Controls.Add(this.cmdPlaySound);
			this.pnlSound.Location = new System.Drawing.Point(8, 64);
			this.pnlSound.Name = "pnlSound";
			this.pnlSound.Size = new System.Drawing.Size(482, 392);
			this.pnlSound.TabIndex = 23;
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(152, 88);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(136, 32);
			this.label3.TabIndex = 70;
			this.label3.Text = "(0 means sound can play twice simultaniously)";
			// 
			// txtSoundSecondsBetweenPlays
			// 
			this.txtSoundSecondsBetweenPlays.Location = new System.Drawing.Point(152, 64);
			this.txtSoundSecondsBetweenPlays.Name = "txtSoundSecondsBetweenPlays";
			this.txtSoundSecondsBetweenPlays.Size = new System.Drawing.Size(80, 20);
			this.txtSoundSecondsBetweenPlays.TabIndex = 69;
			this.txtSoundSecondsBetweenPlays.Text = "0";
			this.txtSoundSecondsBetweenPlays.TextChanged += new System.EventHandler(this.txtSoundSecondsBetweenPlays_TextChanged);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 64);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(136, 16);
			this.label2.TabIndex = 65;
			this.label2.Text = "Seconds Between Plays:";
			// 
			// nmrMaxSounds
			// 
			this.nmrMaxSounds.Location = new System.Drawing.Point(152, 24);
			this.nmrMaxSounds.Name = "nmrMaxSounds";
			this.nmrMaxSounds.Size = new System.Drawing.Size(80, 20);
			this.nmrMaxSounds.TabIndex = 67;
			this.nmrMaxSounds.Visible = false;
			this.nmrMaxSounds.ValueChanged += new System.EventHandler(this.nmrMaxSounds_ValueChanged);
			// 
			// chkMaxSoundBuffers
			// 
			this.chkMaxSoundBuffers.Location = new System.Drawing.Point(8, 8);
			this.chkMaxSoundBuffers.Name = "chkMaxSoundBuffers";
			this.chkMaxSoundBuffers.Size = new System.Drawing.Size(144, 48);
			this.chkMaxSoundBuffers.TabIndex = 68;
			this.chkMaxSoundBuffers.Text = "Limit the number of times this sound can be played simultaniously";
			this.chkMaxSoundBuffers.Visible = false;
			this.chkMaxSoundBuffers.Click += new System.EventHandler(this.chkMaxSoundBuffers_CheckedChanged);
			// 
			// cmdPlaySound
			// 
			this.cmdPlaySound.Location = new System.Drawing.Point(8, 128);
			this.cmdPlaySound.Name = "cmdPlaySound";
			this.cmdPlaySound.Size = new System.Drawing.Size(80, 24);
			this.cmdPlaySound.TabIndex = 66;
			this.cmdPlaySound.Text = "Play Sound";
			this.cmdPlaySound.Visible = false;
			this.cmdPlaySound.Click += new System.EventHandler(this.cmdPlaySound_Click);
			// 
			// lstErrors
			// 
			this.lstErrors.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lstErrors.BackColor = System.Drawing.SystemColors.ScrollBar;
			this.lstErrors.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.lstErrors.ForeColor = System.Drawing.Color.Red;
			this.lstErrors.Location = new System.Drawing.Point(232, 8);
			this.lstErrors.Name = "lstErrors";
			this.lstErrors.Size = new System.Drawing.Size(256, 52);
			this.lstErrors.TabIndex = 66;
			// 
			// lblFileType
			// 
			this.lblFileType.Location = new System.Drawing.Point(8, 32);
			this.lblFileType.Name = "lblFileType";
			this.lblFileType.Size = new System.Drawing.Size(72, 16);
			this.lblFileType.TabIndex = 46;
			this.lblFileType.Text = "File Type:";
			this.lblFileType.Visible = false;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(72, 16);
			this.label1.TabIndex = 39;
			this.label1.Text = "Table Name:";
			// 
			// cmdExit
			// 
			this.cmdExit.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.cmdExit.Location = new System.Drawing.Point(410, 460);
			this.cmdExit.Name = "cmdExit";
			this.cmdExit.Size = new System.Drawing.Size(80, 24);
			this.cmdExit.TabIndex = 37;
			this.cmdExit.Text = "E&xit";
			this.cmdExit.Click += new System.EventHandler(this.cmdExit_Click);
			// 
			// txtTableName
			// 
			this.txtTableName.Enabled = false;
			this.txtTableName.Location = new System.Drawing.Point(88, 8);
			this.txtTableName.Name = "txtTableName";
			this.txtTableName.Size = new System.Drawing.Size(136, 20);
			this.txtTableName.TabIndex = 38;
			this.txtTableName.Text = "";
			this.txtTableName.TextChanged += new System.EventHandler(this.txtTableName_TextChanged);
			// 
			// cboTableType
			// 
			this.cboTableType.Items.AddRange(new object[] {
															  "0 - Graphic File",
															  "1 - DataTable",
															  "2 - Window Border",
															  "3 - Other / Unknown",
															  "4 - Sound",
															  "5 - SpriteSheet"});
			this.cboTableType.Location = new System.Drawing.Point(88, 32);
			this.cboTableType.Name = "cboTableType";
			this.cboTableType.Size = new System.Drawing.Size(136, 21);
			this.cboTableType.TabIndex = 43;
			this.cboTableType.Visible = false;
			this.cboTableType.SelectedIndexChanged += new System.EventHandler(this.cboTableType_SelectedIndexChanged);
			// 
			// pnlSpriteSheet
			// 
			this.pnlSpriteSheet.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.pnlSpriteSheet.Controls.Add(this.pnlSpriteSheet_Misc1);
			this.pnlSpriteSheet.Controls.Add(this.splitter2);
			this.pnlSpriteSheet.Controls.Add(this.pnlSpriteSheet_Misc2);
			this.pnlSpriteSheet.Location = new System.Drawing.Point(8, 64);
			this.pnlSpriteSheet.Name = "pnlSpriteSheet";
			this.pnlSpriteSheet.Size = new System.Drawing.Size(482, 392);
			this.pnlSpriteSheet.TabIndex = 65;
			// 
			// pnlSpriteSheet_Misc1
			// 
			this.pnlSpriteSheet_Misc1.Controls.Add(this.grdSpriteSheet);
			this.pnlSpriteSheet_Misc1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlSpriteSheet_Misc1.Location = new System.Drawing.Point(0, 0);
			this.pnlSpriteSheet_Misc1.Name = "pnlSpriteSheet_Misc1";
			this.pnlSpriteSheet_Misc1.Size = new System.Drawing.Size(482, 210);
			this.pnlSpriteSheet_Misc1.TabIndex = 60;
			// 
			// grdSpriteSheet
			// 
			this.grdSpriteSheet.DataMember = "";
			this.grdSpriteSheet.Dock = System.Windows.Forms.DockStyle.Fill;
			this.grdSpriteSheet.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.grdSpriteSheet.Location = new System.Drawing.Point(0, 0);
			this.grdSpriteSheet.Name = "grdSpriteSheet";
			this.grdSpriteSheet.Size = new System.Drawing.Size(482, 210);
			this.grdSpriteSheet.TabIndex = 58;
			this.grdSpriteSheet.MouseDown += new System.Windows.Forms.MouseEventHandler(this.grdSpriteSheet_MouseDown);
			// 
			// splitter2
			// 
			this.splitter2.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.splitter2.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.splitter2.Location = new System.Drawing.Point(0, 210);
			this.splitter2.Name = "splitter2";
			this.splitter2.Size = new System.Drawing.Size(482, 6);
			this.splitter2.TabIndex = 59;
			this.splitter2.TabStop = false;
			// 
			// pnlSpriteSheet_Misc2
			// 
			this.pnlSpriteSheet_Misc2.AutoScroll = true;
			this.pnlSpriteSheet_Misc2.Controls.Add(this.pnlSpriteSheet_Misc3);
			this.pnlSpriteSheet_Misc2.Controls.Add(this.cmdRefreshSpriteSheet);
			this.pnlSpriteSheet_Misc2.Controls.Add(this.txtSpriteSheetTransparencyColor);
			this.pnlSpriteSheet_Misc2.Controls.Add(this.label6);
			this.pnlSpriteSheet_Misc2.Controls.Add(this.lblSpriteSheetPicSize);
			this.pnlSpriteSheet_Misc2.Controls.Add(this.cmdSpriteSheetPickColor);
			this.pnlSpriteSheet_Misc2.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.pnlSpriteSheet_Misc2.Location = new System.Drawing.Point(0, 216);
			this.pnlSpriteSheet_Misc2.Name = "pnlSpriteSheet_Misc2";
			this.pnlSpriteSheet_Misc2.Size = new System.Drawing.Size(482, 176);
			this.pnlSpriteSheet_Misc2.TabIndex = 58;
			// 
			// pnlSpriteSheet_Misc3
			// 
			this.pnlSpriteSheet_Misc3.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.pnlSpriteSheet_Misc3.AutoScroll = true;
			this.pnlSpriteSheet_Misc3.Controls.Add(this.picSpriteSheetPreview);
			this.pnlSpriteSheet_Misc3.Location = new System.Drawing.Point(0, 34);
			this.pnlSpriteSheet_Misc3.Name = "pnlSpriteSheet_Misc3";
			this.pnlSpriteSheet_Misc3.Size = new System.Drawing.Size(480, 126);
			this.pnlSpriteSheet_Misc3.TabIndex = 97;
			// 
			// picSpriteSheetPreview
			// 
			this.picSpriteSheetPreview.Location = new System.Drawing.Point(0, 0);
			this.picSpriteSheetPreview.Name = "picSpriteSheetPreview";
			this.picSpriteSheetPreview.Size = new System.Drawing.Size(80, 32);
			this.picSpriteSheetPreview.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
			this.picSpriteSheetPreview.TabIndex = 94;
			this.picSpriteSheetPreview.TabStop = false;
			// 
			// cmdRefreshSpriteSheet
			// 
			this.cmdRefreshSpriteSheet.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.cmdRefreshSpriteSheet.Location = new System.Drawing.Point(384, 8);
			this.cmdRefreshSpriteSheet.Name = "cmdRefreshSpriteSheet";
			this.cmdRefreshSpriteSheet.Size = new System.Drawing.Size(96, 24);
			this.cmdRefreshSpriteSheet.TabIndex = 96;
			this.cmdRefreshSpriteSheet.Text = "Refresh Image";
			this.cmdRefreshSpriteSheet.Click += new System.EventHandler(this.cmdRefreshSpriteSheet_Click);
			// 
			// txtSpriteSheetTransparencyColor
			// 
			this.txtSpriteSheetTransparencyColor.Enabled = false;
			this.txtSpriteSheetTransparencyColor.Location = new System.Drawing.Point(96, 8);
			this.txtSpriteSheetTransparencyColor.Name = "txtSpriteSheetTransparencyColor";
			this.txtSpriteSheetTransparencyColor.TabIndex = 94;
			this.txtSpriteSheetTransparencyColor.Text = "";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(0, 10);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(104, 16);
			this.label6.TabIndex = 93;
			this.label6.Text = "Transparent Color:";
			// 
			// lblSpriteSheetPicSize
			// 
			this.lblSpriteSheetPicSize.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.lblSpriteSheetPicSize.Location = new System.Drawing.Point(0, 160);
			this.lblSpriteSheetPicSize.Name = "lblSpriteSheetPicSize";
			this.lblSpriteSheetPicSize.Size = new System.Drawing.Size(248, 16);
			this.lblSpriteSheetPicSize.TabIndex = 92;
			this.lblSpriteSheetPicSize.Text = "<Pic Size>";
			// 
			// cmdSpriteSheetPickColor
			// 
			this.cmdSpriteSheetPickColor.Location = new System.Drawing.Point(192, 8);
			this.cmdSpriteSheetPickColor.Name = "cmdSpriteSheetPickColor";
			this.cmdSpriteSheetPickColor.Size = new System.Drawing.Size(24, 20);
			this.cmdSpriteSheetPickColor.TabIndex = 95;
			this.cmdSpriteSheetPickColor.Text = "...";
			this.cmdSpriteSheetPickColor.Click += new System.EventHandler(this.cmdSpriteSheetPickColor_Click);
			// 
			// grdTable
			// 
			this.grdTable.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.grdTable.DataMember = "";
			this.grdTable.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.grdTable.Location = new System.Drawing.Point(8, 64);
			this.grdTable.Name = "grdTable";
			this.grdTable.Size = new System.Drawing.Size(482, 388);
			this.grdTable.TabIndex = 56;
			this.grdTable.Visible = false;
			this.grdTable.MouseUp += new System.Windows.Forms.MouseEventHandler(this.grdTable_MouseUp);
			// 
			// pnlBorder
			// 
			this.pnlBorder.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.pnlBorder.Controls.Add(this.cboBorder_LowerMiddle);
			this.pnlBorder.Controls.Add(this.cboBorderFillType);
			this.pnlBorder.Controls.Add(this.cboBorder_LowerRight);
			this.pnlBorder.Controls.Add(this.cboBorder_MiddleRight);
			this.pnlBorder.Controls.Add(this.cboBorder_UpperRight);
			this.pnlBorder.Controls.Add(this.cboBorder_UpperMiddle);
			this.pnlBorder.Controls.Add(this.cboBorder_LowerLeft);
			this.pnlBorder.Controls.Add(this.cboBorder_MiddleLeft);
			this.pnlBorder.Controls.Add(this.cboBorder_UpperLeft);
			this.pnlBorder.Controls.Add(this.label5);
			this.pnlBorder.Controls.Add(this.txtBoder_Right);
			this.pnlBorder.Controls.Add(this.txtBoder_Bottom);
			this.pnlBorder.Controls.Add(this.txtBoder_Top);
			this.pnlBorder.Controls.Add(this.label4);
			this.pnlBorder.Controls.Add(this.txtBoder_Left);
			this.pnlBorder.Controls.Add(this.lblBorderFillColor);
			this.pnlBorder.Controls.Add(this.lblBorderFillGraphic);
			this.pnlBorder.Controls.Add(this.chkBorderFill_Stretch);
			this.pnlBorder.Controls.Add(this.cmdBorderFill_PickColor);
			this.pnlBorder.Controls.Add(this.txtBorderFill_Color);
			this.pnlBorder.Controls.Add(this.cboBorderFill_Graphic);
			this.pnlBorder.Location = new System.Drawing.Point(8, 64);
			this.pnlBorder.Name = "pnlBorder";
			this.pnlBorder.Size = new System.Drawing.Size(482, 388);
			this.pnlBorder.TabIndex = 55;
			this.pnlBorder.Visible = false;
			// 
			// cboBorder_LowerMiddle
			// 
			this.cboBorder_LowerMiddle.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.cboBorder_LowerMiddle.Location = new System.Drawing.Point(168, 360);
			this.cboBorder_LowerMiddle.Name = "cboBorder_LowerMiddle";
			this.cboBorder_LowerMiddle.Size = new System.Drawing.Size(144, 21);
			this.cboBorder_LowerMiddle.TabIndex = 19;
			this.cboBorder_LowerMiddle.SelectedIndexChanged += new System.EventHandler(this.cboBorder_LowerMiddle_SelectedIndexChanged);
			// 
			// cboBorderFillType
			// 
			this.cboBorderFillType.Items.AddRange(new object[] {
																   "0 - None",
																   "1 - Fill with graphic",
																   "2 - Fill with color"});
			this.cboBorderFillType.Location = new System.Drawing.Point(168, 136);
			this.cboBorderFillType.Name = "cboBorderFillType";
			this.cboBorderFillType.Size = new System.Drawing.Size(144, 21);
			this.cboBorderFillType.TabIndex = 0;
			this.cboBorderFillType.SelectedIndexChanged += new System.EventHandler(this.cboBorderFillType_SelectedIndexChanged);
			// 
			// cboBorder_LowerRight
			// 
			this.cboBorder_LowerRight.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.cboBorder_LowerRight.Location = new System.Drawing.Point(362, 360);
			this.cboBorder_LowerRight.Name = "cboBorder_LowerRight";
			this.cboBorder_LowerRight.Size = new System.Drawing.Size(112, 21);
			this.cboBorder_LowerRight.TabIndex = 18;
			this.cboBorder_LowerRight.SelectedIndexChanged += new System.EventHandler(this.cboBorder_LowerRight_SelectedIndexChanged);
			// 
			// cboBorder_MiddleRight
			// 
			this.cboBorder_MiddleRight.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.cboBorder_MiddleRight.Location = new System.Drawing.Point(362, 136);
			this.cboBorder_MiddleRight.Name = "cboBorder_MiddleRight";
			this.cboBorder_MiddleRight.Size = new System.Drawing.Size(112, 21);
			this.cboBorder_MiddleRight.TabIndex = 17;
			this.cboBorder_MiddleRight.SelectedIndexChanged += new System.EventHandler(this.cboBorder_MiddleRight_SelectedIndexChanged);
			// 
			// cboBorder_UpperRight
			// 
			this.cboBorder_UpperRight.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.cboBorder_UpperRight.Location = new System.Drawing.Point(346, 16);
			this.cboBorder_UpperRight.Name = "cboBorder_UpperRight";
			this.cboBorder_UpperRight.Size = new System.Drawing.Size(128, 21);
			this.cboBorder_UpperRight.TabIndex = 16;
			this.cboBorder_UpperRight.SelectedIndexChanged += new System.EventHandler(this.cboBorder_UpperRight_SelectedIndexChanged);
			// 
			// cboBorder_UpperMiddle
			// 
			this.cboBorder_UpperMiddle.Location = new System.Drawing.Point(160, 16);
			this.cboBorder_UpperMiddle.Name = "cboBorder_UpperMiddle";
			this.cboBorder_UpperMiddle.Size = new System.Drawing.Size(128, 21);
			this.cboBorder_UpperMiddle.TabIndex = 15;
			this.cboBorder_UpperMiddle.SelectedIndexChanged += new System.EventHandler(this.cboBorder_UpperMiddle_SelectedIndexChanged);
			// 
			// cboBorder_LowerLeft
			// 
			this.cboBorder_LowerLeft.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.cboBorder_LowerLeft.Location = new System.Drawing.Point(8, 360);
			this.cboBorder_LowerLeft.Name = "cboBorder_LowerLeft";
			this.cboBorder_LowerLeft.Size = new System.Drawing.Size(128, 21);
			this.cboBorder_LowerLeft.TabIndex = 14;
			this.cboBorder_LowerLeft.SelectedIndexChanged += new System.EventHandler(this.cboBorder_LowerLeft_SelectedIndexChanged);
			// 
			// cboBorder_MiddleLeft
			// 
			this.cboBorder_MiddleLeft.Location = new System.Drawing.Point(8, 136);
			this.cboBorder_MiddleLeft.Name = "cboBorder_MiddleLeft";
			this.cboBorder_MiddleLeft.Size = new System.Drawing.Size(112, 21);
			this.cboBorder_MiddleLeft.TabIndex = 13;
			this.cboBorder_MiddleLeft.SelectedIndexChanged += new System.EventHandler(this.cboBorder_MiddleLeft_SelectedIndexChanged);
			// 
			// cboBorder_UpperLeft
			// 
			this.cboBorder_UpperLeft.Location = new System.Drawing.Point(8, 16);
			this.cboBorder_UpperLeft.Name = "cboBorder_UpperLeft";
			this.cboBorder_UpperLeft.Size = new System.Drawing.Size(128, 21);
			this.cboBorder_UpperLeft.TabIndex = 12;
			this.cboBorder_UpperLeft.SelectedIndexChanged += new System.EventHandler(this.cboBorder_UpperLeft_SelectedIndexChanged);
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(120, 136);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(56, 16);
			this.label5.TabIndex = 11;
			this.label5.Text = "Fill Type:";
			// 
			// txtBoder_Right
			// 
			this.txtBoder_Right.Location = new System.Drawing.Point(264, 80);
			this.txtBoder_Right.Name = "txtBoder_Right";
			this.txtBoder_Right.Size = new System.Drawing.Size(48, 20);
			this.txtBoder_Right.TabIndex = 10;
			this.txtBoder_Right.Text = "0";
			this.txtBoder_Right.TextChanged += new System.EventHandler(this.txtBoder_Right_TextChanged);
			// 
			// txtBoder_Bottom
			// 
			this.txtBoder_Bottom.Location = new System.Drawing.Point(216, 104);
			this.txtBoder_Bottom.Name = "txtBoder_Bottom";
			this.txtBoder_Bottom.Size = new System.Drawing.Size(48, 20);
			this.txtBoder_Bottom.TabIndex = 9;
			this.txtBoder_Bottom.Text = "0";
			this.txtBoder_Bottom.TextChanged += new System.EventHandler(this.txtBoder_Bottom_TextChanged);
			// 
			// txtBoder_Top
			// 
			this.txtBoder_Top.Location = new System.Drawing.Point(216, 56);
			this.txtBoder_Top.Name = "txtBoder_Top";
			this.txtBoder_Top.Size = new System.Drawing.Size(48, 20);
			this.txtBoder_Top.TabIndex = 8;
			this.txtBoder_Top.Text = "0";
			this.txtBoder_Top.TextChanged += new System.EventHandler(this.txtBoder_Top_TextChanged);
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(120, 56);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(72, 24);
			this.label4.TabIndex = 7;
			this.label4.Text = "Inner Border Range:";
			// 
			// txtBoder_Left
			// 
			this.txtBoder_Left.Location = new System.Drawing.Point(168, 80);
			this.txtBoder_Left.Name = "txtBoder_Left";
			this.txtBoder_Left.Size = new System.Drawing.Size(48, 20);
			this.txtBoder_Left.TabIndex = 6;
			this.txtBoder_Left.Text = "0";
			this.txtBoder_Left.TextChanged += new System.EventHandler(this.txtBoder_Left_TextChanged);
			// 
			// lblBorderFillColor
			// 
			this.lblBorderFillColor.Location = new System.Drawing.Point(144, 160);
			this.lblBorderFillColor.Name = "lblBorderFillColor";
			this.lblBorderFillColor.Size = new System.Drawing.Size(48, 16);
			this.lblBorderFillColor.TabIndex = 4;
			this.lblBorderFillColor.Text = "Color:";
			// 
			// lblBorderFillGraphic
			// 
			this.lblBorderFillGraphic.Location = new System.Drawing.Point(144, 160);
			this.lblBorderFillGraphic.Name = "lblBorderFillGraphic";
			this.lblBorderFillGraphic.Size = new System.Drawing.Size(48, 16);
			this.lblBorderFillGraphic.TabIndex = 3;
			this.lblBorderFillGraphic.Text = "Graphic:";
			// 
			// chkBorderFill_Stretch
			// 
			this.chkBorderFill_Stretch.Location = new System.Drawing.Point(176, 184);
			this.chkBorderFill_Stretch.Name = "chkBorderFill_Stretch";
			this.chkBorderFill_Stretch.Size = new System.Drawing.Size(112, 16);
			this.chkBorderFill_Stretch.TabIndex = 1;
			this.chkBorderFill_Stretch.Text = "Stretch To Fill";
			this.chkBorderFill_Stretch.CheckedChanged += new System.EventHandler(this.chkBorderFill_Stretch_CheckedChanged);
			// 
			// cmdBorderFill_PickColor
			// 
			this.cmdBorderFill_PickColor.Location = new System.Drawing.Point(290, 160);
			this.cmdBorderFill_PickColor.Name = "cmdBorderFill_PickColor";
			this.cmdBorderFill_PickColor.Size = new System.Drawing.Size(20, 20);
			this.cmdBorderFill_PickColor.TabIndex = 21;
			this.cmdBorderFill_PickColor.Text = "...";
			this.cmdBorderFill_PickColor.Visible = false;
			this.cmdBorderFill_PickColor.Click += new System.EventHandler(this.cmdBorderFill_PickColor_Click);
			// 
			// txtBorderFill_Color
			// 
			this.txtBorderFill_Color.Enabled = false;
			this.txtBorderFill_Color.Location = new System.Drawing.Point(192, 160);
			this.txtBorderFill_Color.Name = "txtBorderFill_Color";
			this.txtBorderFill_Color.TabIndex = 20;
			this.txtBorderFill_Color.Text = "";
			this.txtBorderFill_Color.Visible = false;
			// 
			// cboBorderFill_Graphic
			// 
			this.cboBorderFill_Graphic.Location = new System.Drawing.Point(192, 160);
			this.cboBorderFill_Graphic.Name = "cboBorderFill_Graphic";
			this.cboBorderFill_Graphic.Size = new System.Drawing.Size(120, 21);
			this.cboBorderFill_Graphic.TabIndex = 2;
			this.cboBorderFill_Graphic.SelectedIndexChanged += new System.EventHandler(this.cboBorderFill_Graphic_SelectedIndexChanged);
			// 
			// pnlPicture
			// 
			this.pnlPicture.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.pnlPicture.Controls.Add(this.pnlGraphic_Misc1);
			this.pnlPicture.Controls.Add(this.cmdPicTransparencyColor);
			this.pnlPicture.Controls.Add(this.txtPicTransparencyColor);
			this.pnlPicture.Controls.Add(this.lblTransparentColor);
			this.pnlPicture.Controls.Add(this.lblPicSize);
			this.pnlPicture.Controls.Add(this.txtRealPic_Bottom);
			this.pnlPicture.Controls.Add(this.txtRealPic_Top);
			this.pnlPicture.Controls.Add(this.txtRealPic_Right);
			this.pnlPicture.Controls.Add(this.lblRealPic);
			this.pnlPicture.Controls.Add(this.txtRealPic_Left);
			this.pnlPicture.Controls.Add(this.textBox1);
			this.pnlPicture.Controls.Add(this.button1);
			this.pnlPicture.Location = new System.Drawing.Point(8, 64);
			this.pnlPicture.Name = "pnlPicture";
			this.pnlPicture.Size = new System.Drawing.Size(482, 392);
			this.pnlPicture.TabIndex = 63;
			// 
			// pnlGraphic_Misc1
			// 
			this.pnlGraphic_Misc1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.pnlGraphic_Misc1.AutoScroll = true;
			this.pnlGraphic_Misc1.Controls.Add(this.picPreview);
			this.pnlGraphic_Misc1.Location = new System.Drawing.Point(0, 120);
			this.pnlGraphic_Misc1.Name = "pnlGraphic_Misc1";
			this.pnlGraphic_Misc1.Size = new System.Drawing.Size(480, 240);
			this.pnlGraphic_Misc1.TabIndex = 71;
			// 
			// picPreview
			// 
			this.picPreview.Location = new System.Drawing.Point(0, 0);
			this.picPreview.Name = "picPreview";
			this.picPreview.Size = new System.Drawing.Size(280, 88);
			this.picPreview.TabIndex = 62;
			this.picPreview.TabStop = false;
			// 
			// cmdPicTransparencyColor
			// 
			this.cmdPicTransparencyColor.Location = new System.Drawing.Point(176, 88);
			this.cmdPicTransparencyColor.Name = "cmdPicTransparencyColor";
			this.cmdPicTransparencyColor.Size = new System.Drawing.Size(20, 20);
			this.cmdPicTransparencyColor.TabIndex = 70;
			this.cmdPicTransparencyColor.Text = "...";
			this.cmdPicTransparencyColor.Click += new System.EventHandler(this.cmdPicTransparencyColor_Click);
			// 
			// txtPicTransparencyColor
			// 
			this.txtPicTransparencyColor.Enabled = false;
			this.txtPicTransparencyColor.Location = new System.Drawing.Point(80, 88);
			this.txtPicTransparencyColor.Name = "txtPicTransparencyColor";
			this.txtPicTransparencyColor.TabIndex = 69;
			this.txtPicTransparencyColor.Text = "";
			// 
			// lblTransparentColor
			// 
			this.lblTransparentColor.Location = new System.Drawing.Point(8, 88);
			this.lblTransparentColor.Name = "lblTransparentColor";
			this.lblTransparentColor.Size = new System.Drawing.Size(72, 24);
			this.lblTransparentColor.TabIndex = 68;
			this.lblTransparentColor.Text = "Transparent Color:";
			// 
			// lblPicSize
			// 
			this.lblPicSize.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.lblPicSize.Location = new System.Drawing.Point(8, 368);
			this.lblPicSize.Name = "lblPicSize";
			this.lblPicSize.Size = new System.Drawing.Size(248, 16);
			this.lblPicSize.TabIndex = 67;
			this.lblPicSize.Text = "<Pic Size>";
			// 
			// txtRealPic_Bottom
			// 
			this.txtRealPic_Bottom.Location = new System.Drawing.Point(128, 56);
			this.txtRealPic_Bottom.Name = "txtRealPic_Bottom";
			this.txtRealPic_Bottom.Size = new System.Drawing.Size(48, 20);
			this.txtRealPic_Bottom.TabIndex = 65;
			this.txtRealPic_Bottom.Text = "0";
			this.txtRealPic_Bottom.TextChanged += new System.EventHandler(this.txtRealPic_Bottom_TextChanged);
			// 
			// txtRealPic_Top
			// 
			this.txtRealPic_Top.Location = new System.Drawing.Point(128, 8);
			this.txtRealPic_Top.Name = "txtRealPic_Top";
			this.txtRealPic_Top.Size = new System.Drawing.Size(48, 20);
			this.txtRealPic_Top.TabIndex = 64;
			this.txtRealPic_Top.Text = "0";
			this.txtRealPic_Top.TextChanged += new System.EventHandler(this.txtRealPic_Top_TextChanged);
			// 
			// txtRealPic_Right
			// 
			this.txtRealPic_Right.Location = new System.Drawing.Point(176, 32);
			this.txtRealPic_Right.Name = "txtRealPic_Right";
			this.txtRealPic_Right.Size = new System.Drawing.Size(48, 20);
			this.txtRealPic_Right.TabIndex = 63;
			this.txtRealPic_Right.Text = "0";
			this.txtRealPic_Right.TextChanged += new System.EventHandler(this.txtRealPic_Right_TextChanged);
			// 
			// lblRealPic
			// 
			this.lblRealPic.Location = new System.Drawing.Point(8, 8);
			this.lblRealPic.Name = "lblRealPic";
			this.lblRealPic.Size = new System.Drawing.Size(72, 32);
			this.lblRealPic.TabIndex = 66;
			this.lblRealPic.Text = "Real Graphic Borders:";
			// 
			// txtRealPic_Left
			// 
			this.txtRealPic_Left.Location = new System.Drawing.Point(80, 32);
			this.txtRealPic_Left.Name = "txtRealPic_Left";
			this.txtRealPic_Left.Size = new System.Drawing.Size(48, 20);
			this.txtRealPic_Left.TabIndex = 62;
			this.txtRealPic_Left.Text = "0";
			this.txtRealPic_Left.TextChanged += new System.EventHandler(this.txtRealPic_Left_TextChanged);
			// 
			// textBox1
			// 
			this.textBox1.Enabled = false;
			this.textBox1.Location = new System.Drawing.Point(64, 88);
			this.textBox1.Name = "textBox1";
			this.textBox1.TabIndex = 69;
			this.textBox1.Text = "";
			this.textBox1.Visible = false;
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(160, 88);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(20, 20);
			this.button1.TabIndex = 70;
			this.button1.Text = "...";
			this.button1.Visible = false;
			// 
			// frmMain
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(760, 489);
			this.Controls.Add(this.panel2);
			this.Controls.Add(this.splitter1);
			this.Controls.Add(this.panel1);
			this.Menu = this.mainMenu1;
			this.Name = "frmMain";
			this.Text = "DS Gob File Editor";
			this.Load += new System.EventHandler(this.frmMain_Load);
			this.panel1.ResumeLayout(false);
			this.panel2.ResumeLayout(false);
			this.pnlSound.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.nmrMaxSounds)).EndInit();
			this.pnlSpriteSheet.ResumeLayout(false);
			this.pnlSpriteSheet_Misc1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.grdSpriteSheet)).EndInit();
			this.pnlSpriteSheet_Misc2.ResumeLayout(false);
			this.pnlSpriteSheet_Misc3.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.grdTable)).EndInit();
			this.pnlBorder.ResumeLayout(false);
			this.pnlPicture.ResumeLayout(false);
			this.pnlGraphic_Misc1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new frmMain());
		}
		#endregion


		private void frmMain_Load(object sender, System.EventArgs e)
		{
			RefreshButtons( null );		
		}


		private void cmdAddTable_Click(object sender, System.EventArgs e)
		{
			string sNewName = "";
			DSInputBox oInput = new DSInputBox();
			DSGobTable oTable = null;
			System.Windows.Forms.TreeNode oParentNode = null;
			System.Windows.Forms.TreeNode oTableNode = null;


			sNewName = oInput.InputBox( "Please enter the new table's name:","New Table 1" );
			if( oInput.Canceled == false )
			{
				//Do we have anything selected?
				if( treTables.SelectedNode != null )
				{
					oParentNode = treTables.SelectedNode;
				}
				else
				{
					oParentNode = treTables.Nodes[0];
				}
				oTableNode = new TreeNode( sNewName,4,4 );
				oTableNode.Expand();
				oParentNode.Nodes.Add( oTableNode );
				oParentNode.Expand();

				//Update the GOB
				oTable = new DSGobTable();
				oTable.TableName = sNewName;
				oTable.FolderName = GetNodeFolder( oTableNode );
				m_oGob.AddTable( oTable );

				treTables.SelectedNode = oTableNode;
			}
			oInput = null;
		}

		private void cmdAddFile_Click(object sender, System.EventArgs e)
		{
			int nImageIndex = 0;
			string sTempKeyName = "";
			string sNewName = "";
			string sFileName = "";
			DSInputBox oInput = new DSInputBox();
			DSGobTable oTable = null;
			MemoryStream oMemoryStream = null;
			OpenFileDialog oOpenFileDialog = new OpenFileDialog();
			System.Windows.Forms.TreeNode oTableNode = null;
			System.Windows.Forms.TreeNode oParentNode = null;


			if( m_sPathLastLoadedFrom.Length > 0 )
			{
				oOpenFileDialog.InitialDirectory = m_sPathLastLoadedFrom;
			}
			else
			{
				oOpenFileDialog.InitialDirectory = DSMisc.GetDevelopmentAppPath();
			}
			oOpenFileDialog.Filter = "Gob files (*.gob)|*.gob|All files (*.*)|*.*" ;
			oOpenFileDialog.FilterIndex = 2;
			oOpenFileDialog.Multiselect = true;
			oOpenFileDialog.RestoreDirectory = true;
			
			if( oOpenFileDialog.ShowDialog() == DialogResult.OK )
			{
				for( int i=0 ; i<oOpenFileDialog.FileNames.Length ; i++ )
				{
					sFileName = oOpenFileDialog.FileNames[ i ];
					m_sPathLastLoadedFrom = System.IO.Path.GetFullPath( sFileName );
					sTempKeyName = System.IO.Path.GetFileNameWithoutExtension( sFileName );
					sNewName = oInput.InputBox( "Please enter the new table's name:",sTempKeyName );
					if( oInput.Canceled == false )
					{
						//Create a table based upon the users naming convention
						oTable = new DSGobTable();
						oMemoryStream = DSMisc.GetMemStreamFromFile( sFileName );
						oTable.AddFile( oMemoryStream );
						oTable.TableName = sNewName;
						oTable.TableType = GetDefaultDataTypeFromFileName( sFileName );

						//Do we have anything selected?
						if( treTables.SelectedNode != null )
						{
							oParentNode = treTables.SelectedNode;
						}
						else if( treTables.Nodes.Count > 0 )
						{
							oParentNode = treTables.Nodes[0];
						}
						else
						{
							oParentNode = treTables.Nodes.Add( "GOB File" );
						}
						nImageIndex = TableTypeToImageIndex( oTable );
						oTableNode = new TreeNode( sNewName,nImageIndex,nImageIndex );
						oTableNode.Expand();
						oParentNode.Nodes.Add( oTableNode );
						oParentNode.Expand();

						//Has to be after the node selection
						oTable.FolderName = GetNodeFolder( oTableNode );
						oTable.OriginalFileName = sFileName;
						m_oGob.AddTable( oTable );

						//CheckForPowersOf2Warning( oOpenFileDialog.FileName );
					}
				}
				//Select the new node
				treTables.SelectedNode = oTableNode;

				oInput = null;
			}
		}

		private void cmdSaveTableToFile_Click(object sender, System.EventArgs e)
		{
			SaveFileDialog oSaveFileDialog = new SaveFileDialog();
			byte[] baMemoryFile;
			Stream oStreamOut = null;
			BinaryWriter oBinWriter = null;
			DSGobTable oTable = null;


			oTable = GetSelectedTable();

			oSaveFileDialog.InitialDirectory = oTable.OriginalFileName;
			oSaveFileDialog.Filter = "Gob files (*.gob)|*.gob|All files (*.*)|*.*" ;
			oSaveFileDialog.FilterIndex = 2;
			oSaveFileDialog.RestoreDirectory = true;

			if( oSaveFileDialog.ShowDialog() == DialogResult.OK )
			{
				baMemoryFile = oTable.File.ToArray();

				oStreamOut = (Stream)File.OpenWrite( oSaveFileDialog.FileName );
				oBinWriter = new BinaryWriter( oStreamOut ); 
				oBinWriter.Write( baMemoryFile,0,baMemoryFile.Length );
				oBinWriter.Close();
			}
		}

		private void cmdUpdateTableFromFile_Click(object sender, System.EventArgs e)
		{
			DSInputBox oInput = new DSInputBox();
			DSGobTable oTable = null;
			MemoryStream oMemoryStream = null;
			OpenFileDialog oOpenFileDialog = new OpenFileDialog();


			oTable = GetSelectedTable();

			oOpenFileDialog.InitialDirectory = oTable.OriginalFileName;
			oOpenFileDialog.FileName = oTable.OriginalFileName;
			oOpenFileDialog.Filter = "Gob files (*.gob)|*.gob|All files (*.*)|*.*" ;
			oOpenFileDialog.FilterIndex = 2;
			oOpenFileDialog.RestoreDirectory = true;

			if( oOpenFileDialog.ShowDialog() == DialogResult.OK )
			{
				//Create a table based upon the users naming convention
				oMemoryStream = DSMisc.GetMemStreamFromFile( oOpenFileDialog.FileName );
				oTable.OriginalFileName = oOpenFileDialog.FileName;
				oTable.AddFile( oMemoryStream );

				//CheckForPowersOf2Warning( oOpenFileDialog.FileName );
				RefreshButtons( oTable );
			}
		}
		
		private void cmdDeleteTable_Click(object sender, System.EventArgs e)
		{
			DSGobTable oTable = null;
			bool bReferenced = false;
			string sReferencedBy = "";


			//Is this a graphic being used by a border?
			oTable = GetSelectedTable();
			if( oTable != null )
			{
				if( oTable.TableType == enumTableType.Graphic )
				{
					//Now check to see if any the borders use this key
					foreach( DSGobTable oLoopTable in m_oGob.Tables.GetValueList() )
					{
						if( oLoopTable.TableType == enumTableType.Border )
						{
							for( int i=0 ; i<8 ; i++ )
							{
								if( oLoopTable.BorderGraphicKey[ i ] == oTable.TableName )
								{
									sReferencedBy = oLoopTable.TableName;
									if( sReferencedBy.Length > 0 ){ sReferencedBy += ", "; }
									bReferenced = true;
								}
							}

							if( oLoopTable.BorderFillGraphicKey == oTable.TableName )
							{
								sReferencedBy = oLoopTable.TableName;
								if( sReferencedBy.Length > 0 ){ sReferencedBy += ", "; }
								bReferenced = true;
							}
						}
					}
				}
			

				if( bReferenced == true )
				{
					MessageBox.Show( "This graphic is referenced by the border(s) " + sReferencedBy + " and cannot be deleted." );
				}
				else
				{
					m_oGob.RemoveTable( oTable );
					treTables.Nodes.Remove( treTables.SelectedNode );
				}
			}
		}

		private void cboTableType_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			DSGobTable oTable = null;
			int nTemp = 0;


			if( m_bChangingTableType == false )
			{
				m_bChangingTableType = true;

				if( cboTableType.SelectedIndex != -1 )
				{
					oTable = GetSelectedTable();
					nTemp = (int)Convert.ToInt64( cboTableType.Text.Substring(0,1) );
					oTable.TableType = (enumTableType)nTemp;
					nTemp = TableTypeToImageIndex( oTable );

					//For some reason changing the selected image index recalls this code
					treTables.SelectedNode.ImageIndex = nTemp;
					treTables.SelectedNode.SelectedImageIndex = nTemp;

					//Our table type changed
					if( oTable.TableType != enumTableType.Border )
					{
						for( int i=0 ; i<8 ; i++ )
						{
							oTable.BorderGraphicKey[ i ] = "";
						}
					}

					RefreshButtons( oTable );
				}

				m_bChangingTableType = false;
			}
		}
		private void txtTableName_TextChanged(object sender, System.EventArgs e)
		{
			GetSelectedTable().TableName = txtTableName.Text;
		}

		private void mnuFile_Save_Click(object sender, System.EventArgs e)
		{
			if( m_oGob.FileName.Length == 0 )
			{
				mnuFile_SaveAs_Click( null,null );
			}
			else
			{
				m_oGob.SaveGobFile();
			}
		}

		private void mnuFile_SaveAs_Click(object sender, System.EventArgs e)
		{
			SaveFileDialog oSaveFileDialog = new SaveFileDialog();

			oSaveFileDialog.InitialDirectory = m_sGOBLoadedFrom;
			oSaveFileDialog.Filter = "Gob files (*.gob)|*.gob|All files (*.*)|*.*" ;
			oSaveFileDialog.FilterIndex = 1;
			oSaveFileDialog.RestoreDirectory = true;

			if( oSaveFileDialog.ShowDialog() == DialogResult.OK )
			{
				m_oGob.SaveGobFile( oSaveFileDialog.FileName );			
			}
		}
		private void cmdExit_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void mnuFile_Open_Click(object sender, System.EventArgs e)
		{
			OpenFileDialog oOpenFileDialog = new OpenFileDialog();

			oOpenFileDialog.InitialDirectory = DSMisc.GetDevelopmentAppPath();
			oOpenFileDialog.Filter = "Gob files (*.gob)|*.gob|All files (*.*)|*.*" ;
			oOpenFileDialog.FilterIndex = 1;
			oOpenFileDialog.RestoreDirectory = true;

			if( oOpenFileDialog.ShowDialog() == DialogResult.OK )
			{
				m_sGOBLoadedFrom = oOpenFileDialog.FileName;
				m_oGob.LoadGobFile( oOpenFileDialog.FileName );			
				m_sTableSelected = "";
				PopulateTreeview();
			}
		}

		private void cmdAddFolder_Click(object sender, System.EventArgs e)
		{
			string sNewName = "";
			//string sParentName = "";
			DSInputBox oInput = new DSInputBox();
			//System.Windows.Forms.TreeNode oLoopNode = null;
			System.Windows.Forms.TreeNode oTableNode = null;
			System.Windows.Forms.TreeNode oParentNode = null;


			sNewName = oInput.InputBox( "Please enter the new folder's name:","Folder 1" );
			if( oInput.Canceled == false )
			{
				if( treTables.SelectedNode != null )
				{
					if( treTables.SelectedNode.SelectedImageIndex != 0 && treTables.SelectedNode != treTables.Nodes[0])
					{
						oParentNode = treTables.SelectedNode.Parent;
					}
					else
					{
						oParentNode = treTables.SelectedNode;
					}
				}
				else if( treTables.Nodes.Count > 0 )
				{
					oParentNode = treTables.Nodes[0];
				}
				else
				{
					oParentNode = treTables.Nodes.Add( "GOB File" );
				}

				/*//Get the parent folder if there is one
				sParentName = GetNodeFolder( treTables.SelectedNode );
				if( sParentName.Length > 0 )
				{
					sParentName = sParentName + @"\";
				}
				m_oFolders.Add( sParentName + sNewName );*/
				

				//Do we have anything selected?
				oTableNode = new TreeNode( sNewName,0,0 );
				oTableNode.Expand();
				oParentNode.Nodes.Add( oTableNode );
				oParentNode.Expand();
			}
			oInput = null;				
		}

		private void mnuTree_CollapseAll_Click(object sender, System.EventArgs e)
		{
			for( int i=0 ; i<treTables.Nodes.Count ; i++ )
			{
				treTables.Nodes[ i ].Collapse();
			}
			if( treTables.Nodes.Count > 0 )
			{
				treTables.Nodes[ 0 ].Expand();
			}
		}
		private void mnuTree_ExpandAll_Click(object sender, System.EventArgs e)
		{
			treTables.Nodes[ 0 ].ExpandAll();
		}

		private void treTables_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if( e.KeyData == System.Windows.Forms.Keys.Delete )
			{
				cmdDeleteTable_Click( null,null );
			}			
		}


		#region Tree Node Management
		private void PopulateTreeview()
		{
			System.Windows.Forms.TreeNode oRootNode = null;
			System.Windows.Forms.TreeNode oTableNode = null;
			System.Windows.Forms.TreeNode oParentNode = null;
			string[] saParsed = null;
			int nTemp = 0;


			RefreshButtons( null );

			//Add our root folder
			oRootNode = new TreeNode( m_cROOTKEY,0,1 );
			oRootNode.Expand();
			treTables.Nodes.Add( oRootNode );

			//Add our folders
			foreach( DSGobTable oLoopTable in m_oGob.Tables.GetValueList() )
			{
				if( oLoopTable.FolderName.Length > 0 )
				{
					saParsed = DSMisc.Split( oLoopTable.FolderName,@"\" );
					oParentNode = treTables.Nodes[ 0 ];
					for( int i=0 ; i<saParsed.Length ; i++ )
					{
						//Now find this child node
						oTableNode = GetNode( oParentNode,saParsed[i] );
						
						if( oTableNode == null )
						{
							//Add this as a child
							oTableNode = new TreeNode( saParsed[i],0,0 );
							oTableNode.Expand();
							oParentNode.Nodes.Add( oTableNode );
							oParentNode.Expand();
						}

						oParentNode = oTableNode;
					}
				}
			}
			/*foreach( string sLoopFolder in m_oFolders )
			{
				saParsed = DSMisc.Split( sLoopFolder,@"\" );
				oParentNode = treTables.Nodes[ 0 ];
				for( int i=0 ; i<saParsed.Length-1 ; i++ )
				{
					//Now find this child node
					oParentNode = GetNode( oParentNode,saParsed[i] );
				}

				//Add this as a child
				oTableNode = new TreeNode( saParsed[ saParsed.Length-1 ],0,0 );
				oTableNode.Expand();
				oParentNode.Nodes.Add( oTableNode );
				oParentNode.Expand();
			}*/


			//Re-add all our table info
			foreach( DSGobTable oLoopTable in m_oGob.Tables.GetValueList() )
			{
				//Find our parent
				if( oLoopTable.FolderName.Length > 0 )
				{
					saParsed = DSMisc.Split( oLoopTable.FolderName,@"\" );
					oParentNode = oRootNode;
					for( int i=0 ; i<saParsed.Length ; i++ )
					{
						//Now find this child node
						oParentNode = GetNode( oParentNode,saParsed[i] );
					}
				}
				else
				{
					oParentNode = treTables.Nodes[ 0 ];
				}
			
				//And add our item
				nTemp = TableTypeToImageIndex( oLoopTable );
				oTableNode = new TreeNode( oLoopTable.TableName,nTemp,nTemp );
				oTableNode.Expand();
				oParentNode.Nodes.Add( oTableNode );
				oParentNode.Expand();

				//Do we highlight this node?
				if( oLoopTable.TableName == m_sTableSelected )
				{
					treTables.SelectedNode = oTableNode;
					RefreshButtons( oLoopTable );
				}
			}


			treTables.SelectedNode = oRootNode;

			mnuFile_Save.Enabled = ( m_oGob.Tables.Count > 0 );
			mnuFile_SaveAs.Enabled = ( m_oGob.Tables.Count > 0 );
		}

		private void treTables_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
			DSGobTable oTable = null;
			
			if( m_sTableSelected != e.Node.Text && e.Node.ImageIndex != 0 && e.Node.ImageIndex != 1 )
			{
				m_sTableSelected = e.Node.Text;
				oTable = m_oGob.GetTable( m_sTableSelected );

				//Populate the comboboxes with our graphic keys in them
				FillWithGraphicKeys( cboBorderFill_Graphic );
				FillWithGraphicKeys( this.cboBorder_UpperLeft );
				FillWithGraphicKeys( this.cboBorder_UpperMiddle );
				FillWithGraphicKeys( this.cboBorder_UpperRight );
				FillWithGraphicKeys( this.cboBorder_MiddleLeft );
				FillWithGraphicKeys( this.cboBorder_MiddleRight );
				FillWithGraphicKeys( this.cboBorder_LowerLeft );
				FillWithGraphicKeys( this.cboBorder_LowerMiddle );
				FillWithGraphicKeys( this.cboBorder_LowerRight );

				RefreshButtons( oTable );
			}
			else
			{
				m_sTableSelected = "";
				RefreshButtons( null );
			}
		}

		private void treTables_ItemDrag(object sender, System.Windows.Forms.ItemDragEventArgs e)
		{
			DoDragDrop(e.Item, DragDropEffects.Move);
		}

		private void treTables_DragOver(object sender, System.Windows.Forms.DragEventArgs e)
		{
			treTables_DragEnter( sender,e );
		}
		private void treTables_DragEnter(object sender, System.Windows.Forms.DragEventArgs e)
		{
			TreeNode oDestinationNode;
			Point oPoint = Point.Empty;


			if(e.Data.GetDataPresent("System.Windows.Forms.TreeNode", false))
			{
				oPoint = ((TreeView)sender).PointToClient(new Point(e.X, e.Y));
				oDestinationNode = ((TreeView)sender).GetNodeAt(oPoint);

				if( oDestinationNode.ImageIndex == 0 )
				{
					e.Effect = DragDropEffects.Move;
				}
				else
				{
					e.Effect = DragDropEffects.None;
				}
			}
			else
			{
				e.Effect = DragDropEffects.None;
			}			
		}

		private void treTables_DragDrop(object sender, System.Windows.Forms.DragEventArgs e)
		{
			DSGobTable oTable = null;
			TreeNode oNewNode;
			TreeNode oDestinationNode;
			Point oPoint = Point.Empty;


			if(e.Data.GetDataPresent("System.Windows.Forms.TreeNode", false))
			{
				oPoint = ((TreeView)sender).PointToClient(new Point(e.X, e.Y));
				oDestinationNode = ((TreeView)sender).GetNodeAt(oPoint);
				oNewNode = (TreeNode)e.Data.GetData("System.Windows.Forms.TreeNode");

				oDestinationNode.Nodes.Add( (TreeNode)oNewNode.Clone() );
				oDestinationNode.Expand();
				//Remove Original Node
				oNewNode.Remove();

				//Update the GOB file				
				oTable = m_oGob.GetTable( oNewNode.Text );
				oTable.FolderName = GetNodeFolder( oDestinationNode );
			}
		}

		private System.Windows.Forms.TreeNode GetNode( System.Windows.Forms.TreeNode oStartingNode,string sTextToFind )
		{
			for( int i=0 ; i<oStartingNode.Nodes.Count ; i++ )
			{
				if( oStartingNode.Nodes[ i ].Text == sTextToFind )
				{
					return( oStartingNode.Nodes[ i ] );
				}
			}

			return( null );
		}

		#endregion

		private enumTableType GetDefaultDataTypeFromFileName( string sFileName )
		{
			string sExt = "";

			sExt = System.IO.Path.GetExtension( sFileName );
			sExt = sExt.ToLower();

			if( sExt.Length > 0 && sExt.Substring( 0,1 ) == "." )
			{
				sExt = sExt.Substring( 1 );
			}

			if( sExt == "bmp" || sExt == "jpeg" || sExt == "jpg" || sExt == "png" || sExt == "tff" || sExt == "ico" || sExt == "dds" )
			{
				return( enumTableType.Graphic );
			}
			else if( sExt == "wav" )
			{
				return( enumTableType.Sound );
			}
			else
			{
				return( enumTableType.Other );
			}
		}
		private DSGobTable GetSelectedTable()
		{
			DSGobTable oTable = null;
			oTable = m_oGob.GetTable( m_sTableSelected );
			return( oTable );
		}

		private void RefreshButtons( DSGobTable oTable )
		{
			string sText = "";
			

			if( m_bRefreshingButtons == false )
			{
				m_bRefreshingButtons = true;


				////////////////////////////////////////////////////////////////////////
				//Table Specific
				////////////////////////////////////////////////////////////////////////
				pnlBorder.Visible = false;
				pnlPicture.Visible = false;
				pnlSound.Visible = false;
				grdTable.Visible = false;
				pnlSpriteSheet.Visible = false;

				if( oTable == null )
				{
					////////////////////////////////////////////////////////////////////////
					//General
					////////////////////////////////////////////////////////////////////////
					cmdAddColumn.Enabled = false;
					cmdEditColumn.Enabled = false;
					cmdSaveTableToFile.Enabled = false;
					cmdUpdateTableFromFile.Enabled = false;
					cboTableType.Visible = false;
					lblFileType.Visible = false;
					txtTableName.Enabled = false;
					cmdDeleteTable.Enabled = false;
				}
				else
				{
					////////////////////////////////////////////////////////////////////////
					//General
					////////////////////////////////////////////////////////////////////////
					txtTableName.Text		= oTable.TableName;

					//Select the table type that we see
					cboTableType.SelectedIndex = -1;
					for( int i=0 ; i<cboTableType.Items.Count ; i++ )
					{
						sText = cboTableType.Items[i].ToString();
						if( sText.Substring( 0,1 ) == Convert.ToInt64( oTable.TableType ).ToString() )
						{
							cboTableType.SelectedIndex = i;
						}
					}

					txtTableName.Enabled = true;
					cmdDeleteTable.Enabled = true;
					cmdAddColumn.Enabled			= ( oTable.TableType == enumTableType.DataTable );
					cmdEditColumn.Enabled			= ( oTable.TableType == enumTableType.DataTable );
					cmdSaveTableToFile.Enabled		= ( oTable.IsFile == true && oTable.TableType != enumTableType.DataTable );
					cmdUpdateTableFromFile.Enabled	= ( oTable.IsFile == true && oTable.TableType != enumTableType.DataTable );
					cboTableType.Visible = true;
					lblFileType.Visible = true;


					////////////////////////////////////////////////////////////////////////
					//Table Specific
					////////////////////////////////////////////////////////////////////////
					if( oTable.TableType == enumTableType.DataTable )
					{
						LoadTableData_DataTable( oTable );
					}
					else if( oTable.TableType == enumTableType.Graphic )
					{
						LoadTableData_Picture( oTable );
					}
					else if( oTable.TableType == enumTableType.Border )
					{
						LoadTableData_Border( oTable );
					}
					else if( oTable.TableType == enumTableType.Sound )
					{
						LoadTableData_Sound( oTable );
					}
					else if( oTable.TableType == enumTableType.SpriteSheet )
					{
						LoadTableData_SpriteSheet( oTable );
					}
				}

				m_bRefreshingButtons = false;
			}
		}

		private int TableTypeToImageIndex( DSGobTable oTable )
		{
			if( oTable.TableType == enumTableType.Graphic && oTable.IsFile == true )
			{
				return( 2 );
			}
			else if( oTable.TableType == enumTableType.DataTable )
			{
				return( 3 );
			}
			else if( oTable.TableType == enumTableType.Border )
			{
				return( 5 );
			}
			else if( oTable.TableType == enumTableType.Sound )
			{
				return( 6 );
			}
			else if( oTable.TableType == enumTableType.SpriteSheet )
			{
				return( 7 );
			}
			else
			{
				return( 4 );
			}
		}

		private void SelectItem( System.Windows.Forms.ComboBox oComboBox,string sText,bool bFullTextMustMatch )
		{
			oComboBox.SelectedIndex = -1;

			for( int nIndex=0 ; nIndex<oComboBox.Items.Count ; nIndex++ )
			{
				if( oComboBox.Items[ nIndex ].ToString() == sText ||
					( bFullTextMustMatch = false && 
					  oComboBox.Items[ nIndex ].ToString().Substring( 0,sText.Length ) == sText ) )
				{
					oComboBox.SelectedIndex = nIndex;
					break;
				}
			}
		}

		private string GetNodeFolder( System.Windows.Forms.TreeNode oNode )
		{
			string sFolderName = "";
			System.Windows.Forms.TreeNode oLoopNode = null;


			sFolderName = "";
			oLoopNode = oNode;
			while( oLoopNode != null )
			{
				if( oLoopNode.Parent != null && oLoopNode.SelectedImageIndex == 0 )
				{
					if( sFolderName.Length > 0 )
					{
						sFolderName = @"\" + sFolderName;
					}
					sFolderName = oLoopNode.Text + sFolderName;
				}
				oLoopNode = oLoopNode.Parent;
			}


			return( sFolderName );
		}

		private void UpdatePicture( System.IO.MemoryStream oStream,PictureBox oPictureBox,Label oSizeLabel,int[,] naBorders )
		{
			//This is to slow, so spin it off into its own thread
			UpdatePicThread oTest = new UpdatePicThread( lstErrors,oStream,oPictureBox,oSizeLabel,naBorders );
		}


		#region Border Table Type
		private void LoadTableData_Border( DSGobTable oTable )
		{
			string sText = "";


			pnlBorder.Visible = ( oTable.TableType == enumTableType.Border );

			SelectItem( cboBorder_UpperLeft,	oTable.BorderGraphicKey[0],true );
			SelectItem( cboBorder_UpperMiddle,	oTable.BorderGraphicKey[1],true );
			SelectItem( cboBorder_UpperRight,	oTable.BorderGraphicKey[2],true );
			SelectItem( cboBorder_MiddleLeft,	oTable.BorderGraphicKey[3],true );
			SelectItem( cboBorder_MiddleRight,	oTable.BorderGraphicKey[4],true );
			SelectItem( cboBorder_LowerLeft,	oTable.BorderGraphicKey[5],true );
			SelectItem( cboBorder_LowerMiddle,	oTable.BorderGraphicKey[6],true );
			SelectItem( cboBorder_LowerRight,	oTable.BorderGraphicKey[7],true );
			txtBoder_Left.Text = oTable.BorderFillDiffPoint_Left.ToString();
			txtBoder_Top.Text = oTable.BorderFillDiffPoint_Top.ToString();
			txtBoder_Right.Text = oTable.BorderFillDiffPoint_Right.ToString();
			txtBoder_Bottom.Text = oTable.BorderFillDiffPoint_Bottom.ToString();
			//Setup our fill type
			cboBorderFillType.SelectedIndex = -1;
			for( int i=0 ; i<cboBorderFillType.Items.Count ; i++ )
			{
				sText = cboBorderFillType.Items[i].ToString();
				if( sText.Substring( 0,1 ) == Convert.ToInt64( oTable.BorderFillType ).ToString() )
				{
					cboBorderFillType.SelectedIndex = i;
				}
			}
			lblBorderFillGraphic.Visible	= ( cboBorderFillType.SelectedIndex == 1 );
			cboBorderFill_Graphic.Visible	= ( cboBorderFillType.SelectedIndex == 1 );
			SelectItem( cboBorderFill_Graphic,oTable.BorderFillGraphicKey,true );
			chkBorderFill_Stretch.Visible	= ( cboBorderFillType.SelectedIndex == 1 );
			chkBorderFill_Stretch.Checked	= ( oTable.BorderFillStretch == true );
			lblBorderFillColor.Visible		= ( cboBorderFillType.SelectedIndex == 2 );
			txtBorderFill_Color.Visible		= ( cboBorderFillType.SelectedIndex == 2 );
			cmdBorderFill_PickColor.Visible	= ( cboBorderFillType.SelectedIndex == 2 );
			txtBorderFill_Color.BackColor = System.Drawing.Color.FromArgb( (int)oTable.BorderFillColor );
		}
		private void cboBorder_UpperLeft_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			string[] saBorderKey = GetSelectedTable().BorderGraphicKey;
			saBorderKey[ 0 ] = cboBorder_UpperLeft.Text;
			GetSelectedTable().BorderGraphicKey = saBorderKey;
		}
		private void cboBorder_UpperMiddle_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			string[] saBorderKey = GetSelectedTable().BorderGraphicKey;
			saBorderKey[ 1 ] = cboBorder_UpperMiddle.Text;
			GetSelectedTable().BorderGraphicKey = saBorderKey;
		}
		private void cboBorder_UpperRight_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			string[] saBorderKey = GetSelectedTable().BorderGraphicKey;
			saBorderKey[ 2 ] = cboBorder_UpperRight.Text;
			GetSelectedTable().BorderGraphicKey = saBorderKey;
		}
		private void cboBorder_MiddleLeft_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			string[] saBorderKey = GetSelectedTable().BorderGraphicKey;
			saBorderKey[ 3 ] = cboBorder_MiddleLeft.Text;
			GetSelectedTable().BorderGraphicKey = saBorderKey;
		}
		private void cboBorderFillType_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			DSGobTable oTable = null;
			int nTemp = 0;


			if( m_bChangingBorderFillType == false )
			{
				m_bChangingBorderFillType = true;

				if( cboBorderFillType.SelectedIndex != -1 )
				{
					oTable = GetSelectedTable();
					nTemp = (int)Convert.ToInt64( cboBorderFillType.Text.Substring(0,1) );
					oTable.BorderFillType = (enumBorderFillType)nTemp;

					if( oTable.BorderFillType != enumBorderFillType.Graphic )
					{
						oTable.BorderFillGraphicKey = "";
					}

					RefreshButtons( oTable );
				}

				m_bChangingBorderFillType = false;
			}
		}
		private void cboBorder_MiddleRight_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			string[] saBorderKey = GetSelectedTable().BorderGraphicKey;
			saBorderKey[ 4 ] = cboBorder_MiddleRight.Text;
			GetSelectedTable().BorderGraphicKey = saBorderKey;
		}
		private void cboBorder_LowerLeft_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			string[] saBorderKey = GetSelectedTable().BorderGraphicKey;
			saBorderKey[ 5 ] = cboBorder_LowerLeft.Text;
			GetSelectedTable().BorderGraphicKey = saBorderKey;
		}
		private void cboBorder_LowerMiddle_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			string[] saBorderKey = GetSelectedTable().BorderGraphicKey;
			saBorderKey[ 6 ] = cboBorder_LowerMiddle.Text;
			GetSelectedTable().BorderGraphicKey = saBorderKey;
		}
		private void cboBorder_LowerRight_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			string[] saBorderKey = GetSelectedTable().BorderGraphicKey;
			saBorderKey[ 7 ] = cboBorder_LowerRight.Text;
			GetSelectedTable().BorderGraphicKey = saBorderKey;
		}
		private void txtBoder_Top_TextChanged(object sender, System.EventArgs e)
		{
			DSGobTable oTable = null;

			oTable = GetSelectedTable();

			if( DSMisc.IsNumericLong( txtBoder_Top.Text ) == true )
			{
				oTable.BorderFillDiffPoint_Top = Convert.ToInt64( txtBoder_Top.Text );
				txtRealPic_Top.ForeColor = System.Drawing.Color.Black;
			}
			else
			{
				txtRealPic_Top.ForeColor = System.Drawing.Color.Red;
			}
		}
		private void txtBoder_Left_TextChanged(object sender, System.EventArgs e)
		{
			DSGobTable oTable = null;

			oTable = GetSelectedTable();

			if( DSMisc.IsNumericLong( txtBoder_Left.Text ) == true )
			{
				oTable.BorderFillDiffPoint_Left = Convert.ToInt64( txtBoder_Left.Text );
				txtRealPic_Left.ForeColor = System.Drawing.Color.Black;
			}
			else
			{
				txtRealPic_Left.ForeColor = System.Drawing.Color.Red;
			}
		}
		private void txtBoder_Right_TextChanged(object sender, System.EventArgs e)
		{
			DSGobTable oTable = null;

			oTable = GetSelectedTable();

			if( DSMisc.IsNumericLong( txtBoder_Right.Text ) == true )
			{
				oTable.BorderFillDiffPoint_Right = Convert.ToInt64( txtBoder_Right.Text );
				txtRealPic_Right.ForeColor = System.Drawing.Color.Black;
			}
			else
			{
				txtRealPic_Right.ForeColor = System.Drawing.Color.Red;
			}
		}
		private void txtBoder_Bottom_TextChanged(object sender, System.EventArgs e)
		{
			DSGobTable oTable = null;

			oTable = GetSelectedTable();

			if( DSMisc.IsNumericLong( txtBoder_Bottom.Text ) == true )
			{
				oTable.BorderFillDiffPoint_Bottom = Convert.ToInt64( txtBoder_Bottom.Text );
				txtRealPic_Bottom.ForeColor = System.Drawing.Color.Black;
			}
			else
			{
				txtRealPic_Bottom.ForeColor = System.Drawing.Color.Red;
			}
		}

		private void cboBorderFill_Graphic_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			GetSelectedTable().BorderFillGraphicKey = cboBorderFill_Graphic.Text;
		}
		private void chkBorderFill_Stretch_CheckedChanged(object sender, System.EventArgs e)
		{
			GetSelectedTable().BorderFillStretch = chkBorderFill_Stretch.Checked;		
		}
		private void cboBorderFill_Color_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			GetSelectedTable().BorderFillColor = txtBorderFill_Color.BackColor.ToArgb();
		}

		private void cmdBorderFill_PickColor_Click(object sender, System.EventArgs e)
		{
			dlgColor.ShowDialog();
			GetSelectedTable().BorderFillColor = dlgColor.Color.ToArgb();
			txtBorderFill_Color.BackColor = dlgColor.Color;
		}

		private void FillWithGraphicKeys( System.Windows.Forms.ComboBox oComboBox )
		{
			oComboBox.Items.Clear();
			oComboBox.Text = "";

			foreach( DSGobTable oLoopTable in m_oGob.Tables.GetValueList() )
			{
				if( oLoopTable.TableType == enumTableType.Graphic )
				{
					oComboBox.Items.Add( oLoopTable.TableName );
				}
				//Add in any sprite sheet items too
				else if( oLoopTable.TableType == enumTableType.SpriteSheet )
				{
					for( int i=0 ; i<oLoopTable.DataTable.Rows.Count ; i++ )
					{
						oComboBox.Items.Add( oLoopTable.DataTable.Rows[i][0] );
					}
				}
			}
		}

		#endregion

		#region Sound Table Type
		private void LoadTableData_Sound( DSGobTable oTable )
		{
			pnlSound.Visible = ( oTable.TableType == enumTableType.Sound );
					
			txtSoundSecondsBetweenPlays.Text = oTable.SecondsBetweenPlays.ToString();
			cmdPlaySound.Visible = ( oTable.IsFile == true );//&& oTable.TableType == enumTableType.Sound );
			nmrMaxSounds.Visible = ( oTable.IsFile == true && oTable.TableType == enumTableType.Sound && oTable.MaxSoundInstances != -1 );
			nmrMaxSounds.Minimum = 0;
			nmrMaxSounds.Maximum = 20;
			if( oTable.MaxSoundInstances == -1 )
			{
				nmrMaxSounds.Value = 0;
			}
			else
			{
				nmrMaxSounds.Value = oTable.MaxSoundInstances;
			}
			chkMaxSoundBuffers.Visible = ( oTable.IsFile == true && oTable.TableType == enumTableType.Sound );
			chkMaxSoundBuffers.Checked = ( oTable.MaxSoundInstances != -1 );

			//Check the files length
			PlaySound( GetSelectedTable(),true );
		}
		private void txtSoundSecondsBetweenPlays_TextChanged(object sender, System.EventArgs e)
		{
			if( m_bRefreshingButtons == false )
			{
				if( DSMisc.IsNumericDouble( txtSoundSecondsBetweenPlays.Text ) == true )
				{
					GetSelectedTable().SecondsBetweenPlays = Convert.ToDouble( txtSoundSecondsBetweenPlays.Text );
				}
			}
		}
		private void cmdPlaySound_Click(object sender, System.EventArgs e)
		{
			PlaySound( GetSelectedTable(),false );
		}
		private void PlaySound( DSGobTable oTable,bool bJustTestForErrors )
		{
			SecondaryBuffer oSoundBuffer = null;
			Microsoft.DirectX.DirectSound.Device oDirectSoundDevice = new Microsoft.DirectX.DirectSound.Device();
			oDirectSoundDevice.SetCooperativeLevel( this,CooperativeLevel.Priority );


			lstErrors.Items.Clear();
			oTable.File.Seek( 0,System.IO.SeekOrigin.Begin ); 

			try
			{				
				oSoundBuffer = new SecondaryBuffer( oTable.File,oDirectSoundDevice );
				oSoundBuffer.Play( 0,BufferPlayFlags.Default );

				if( bJustTestForErrors == true )
				{
					oSoundBuffer.Stop();
				}
			}
			catch( Microsoft.DirectX.DirectSound.BufferTooSmallException oEx )
			{
				lstErrors.Items.Add( "Soundbuffer is to small.  " + oTable.File.Length.ToString() + " < 26,508 (" + oEx.Message + ")" );
			}
			catch( System.Exception oEx )
			{
				lstErrors.Items.Add( "Error: " + oEx.Message );
			}
		}


		private void chkMaxSoundBuffers_CheckedChanged(object sender, System.EventArgs e)
		{
			if( m_bRefreshingButtons == false )
			{
				nmrMaxSounds.Visible = ( chkMaxSoundBuffers.Checked == true );

				if( chkMaxSoundBuffers.Checked == false )
				{
					GetSelectedTable().MaxSoundInstances = -1;
				}
				else
				{
					GetSelectedTable().MaxSoundInstances = Convert.ToInt64( nmrMaxSounds.Value );
				}
			}
		}
		private void nmrMaxSounds_ValueChanged(object sender, System.EventArgs e)
		{
			if( m_bRefreshingButtons == false )
			{
				GetSelectedTable().MaxSoundInstances = Convert.ToInt64( nmrMaxSounds.Value );
			}
		}

		#endregion

		#region Graphic Table Type
		private void LoadTableData_Picture( DSGobTable oTable )
		{
			Bitmap oFilePic = null;


			pnlPicture.Visible = ( oTable.TableType == enumTableType.Graphic );
					
			txtRealPic_Left.Text	= oTable.RealPic_Left.ToString();
			txtRealPic_Top.Text		= oTable.RealPic_Top.ToString();
			txtRealPic_Right.Text	= oTable.RealPic_Right.ToString();
			txtRealPic_Bottom.Text	= oTable.RealPic_Bottom.ToString();

			txtPicTransparencyColor.BackColor	= System.Drawing.Color.FromArgb( (int)oTable.AlphaColor );


			//Now populate the picture if its a graphic
			int[,] naBorders = new int[ 0,4 ];
			if( oTable.File != null )
			{
				naBorders = new int[ 1,4 ];
				oFilePic = new Bitmap( oTable.File );
				naBorders[ 0,0 ] = (int)oTable.RealPic_Left;
				naBorders[ 0,1 ] = (int)oTable.RealPic_Top;
				naBorders[ 0,2 ] = (int)( oFilePic.Width - oTable.RealPic_Right - 1 - oTable.RealPic_Left );
				naBorders[ 0,3 ] = (int)( oFilePic.Height - oTable.RealPic_Bottom - 1 - oTable.RealPic_Top );
			}
			UpdatePicture( oTable.File,picPreview,lblPicSize,naBorders );
		}
		private void txtRealPic_Left_TextChanged(object sender, System.EventArgs e)
		{
			DSGobTable oTable = null;

			oTable = GetSelectedTable();

			if( DSMisc.IsNumericLong( txtRealPic_Left.Text ) == true )
			{
				oTable.RealPic_Left = Convert.ToInt64( txtRealPic_Left.Text );
				txtRealPic_Left.ForeColor = System.Drawing.Color.Black;
				LoadTableData_Picture( oTable );
			}
			else
			{
				txtRealPic_Left.ForeColor = System.Drawing.Color.Red;
			}
		}
		private void txtRealPic_Top_TextChanged(object sender, System.EventArgs e)
		{
			DSGobTable oTable = null;

			oTable = GetSelectedTable();

			if( DSMisc.IsNumericLong( txtRealPic_Top.Text ) == true )
			{
				oTable.RealPic_Top = Convert.ToInt64( txtRealPic_Top.Text );
				txtRealPic_Top.ForeColor = System.Drawing.Color.Black;
				LoadTableData_Picture( oTable );
			}
			else
			{
				txtRealPic_Top.ForeColor = System.Drawing.Color.Red;
			}
		}
		private void txtRealPic_Right_TextChanged(object sender, System.EventArgs e)
		{
			DSGobTable oTable = null;

			oTable = GetSelectedTable();

			if( DSMisc.IsNumericLong( txtRealPic_Right.Text ) == true )
			{
				oTable.RealPic_Right = Convert.ToInt64( txtRealPic_Right.Text );
				txtRealPic_Right.ForeColor = System.Drawing.Color.Black;
				LoadTableData_Picture( oTable );
			}
			else
			{
				txtRealPic_Top.ForeColor = System.Drawing.Color.Red;
			}	
		}
		private void txtRealPic_Bottom_TextChanged(object sender, System.EventArgs e)
		{
			DSGobTable oTable = null;

			oTable = GetSelectedTable();

			if( DSMisc.IsNumericLong( txtRealPic_Bottom.Text ) == true )
			{
				oTable.RealPic_Bottom = Convert.ToInt64( txtRealPic_Bottom.Text );
				txtRealPic_Bottom.ForeColor = System.Drawing.Color.Black;
				LoadTableData_Picture( oTable );
			}
			else
			{
				txtRealPic_Bottom.ForeColor = System.Drawing.Color.Red;
			}		
		}

		private void cmdPicTransparencyColor_Click(object sender, System.EventArgs e)
		{
			dlgColor.ShowDialog();
			GetSelectedTable().AlphaColor = dlgColor.Color.ToArgb();
			txtPicTransparencyColor.BackColor = dlgColor.Color;		
		}

		#endregion

		#region DataTable Table Type
		private void LoadTableData_DataTable( DSGobTable oTable )
		{
			grdTable.DataSource = oTable.DataTable;
			grdTable.Visible = ( oTable.TableType == enumTableType.DataTable );
		}


		private void cmdAddColumn_Click(object sender, System.EventArgs e)
		{
			string sNewName = "";
			frmNewColumnNameBox oInput = new frmNewColumnNameBox();
			DSGobTable oTable = null;


			sNewName = oInput.InputBox();
			if( oInput.Canceled == false )
			{
				oTable = GetSelectedTable();
				oTable.AddColumn( sNewName,oInput.SelectedType );
			}
			oInput = null;
		}
		private void grdTable_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			System.Windows.Forms.DataGrid.HitTestInfo oInfo;
			DSGobTable oTable = null;
			string sNewName = "";
			frmNewColumnNameBox oInput = new frmNewColumnNameBox();


			if( e.Button == System.Windows.Forms.MouseButtons.Right )
			{ 
				oTable = GetSelectedTable();
				oInfo = grdTable.HitTest( e.X,e.Y );

				sNewName = oInput.InputBox( oTable.DataTable.Columns[ oInfo.Column ].ColumnName,
					oTable.DataTable.Columns[ oInfo.Column ].DataType );
				if( oInput.Canceled == false )
				{
					oTable.DataTable.Columns[ oInfo.Column ].ColumnName = sNewName;
					oTable.DataTable.Columns[ oInfo.Column ].DataType = oInput.SelectedType;
				}
				oInput = null;
			}
		}
		#endregion

		#region SpriteSheet Table Type
		private void LoadTableData_SpriteSheet( DSGobTable oTable )
		{
			pnlSpriteSheet.Visible = true;

			//Remove our events
			oTable.DataTable.RowChanged		-= new DataRowChangeEventHandler( SpriteSheet_RowChanged );
			oTable.DataTable.ColumnChanged	-= new DataColumnChangeEventHandler( SpriteSheet_ColumnChanged );
			oTable.DataTable.RowDeleted		-= new DataRowChangeEventHandler( SpriteSheet_RowChanged );
			//Now recreate them
			oTable.DataTable.RowChanged		+= new DataRowChangeEventHandler( SpriteSheet_RowChanged );
			oTable.DataTable.ColumnChanged	+= new DataColumnChangeEventHandler( SpriteSheet_ColumnChanged );
			oTable.DataTable.RowDeleted		+= new DataRowChangeEventHandler( SpriteSheet_RowChanged );

			if( oTable.DataTable.Columns.Count == 0 )
			{
				oTable.AddColumn( "SpriteKey",typeof( string ) );
				oTable.AddColumn( "Left",typeof( int ) );
				oTable.AddColumn( "Top",typeof( int ) );
				oTable.AddColumn( "Width",typeof( int ) );
				oTable.AddColumn( "Height",typeof( int ) );
			}

			grdSpriteSheet.DataSource = oTable.DataTable;
			txtSpriteSheetTransparencyColor.BackColor = System.Drawing.Color.FromArgb( (int)oTable.AlphaColor );


			//Now populate the picture if its a graphic
			UpdateSpriteSheetPicture( oTable );
		}


		private void SpriteSheet_RowChanged( object sender,System.Data.DataRowChangeEventArgs e )
		{
			UpdateSpriteSheetPicture( GetSelectedTable() );
		}
		private void SpriteSheet_ColumnChanged( object sender,System.Data.DataColumnChangeEventArgs e )
		{
			UpdateSpriteSheetPicture( GetSelectedTable() );
		}
		private void UpdateSpriteSheetPicture( DSGobTable oTable )
		{
			int[,] naBorders = new int[ oTable.DataTable.Rows.Count,4 ];


			//Go through and render squares around the sub-sprites
			for( int nRow=0 ; nRow<oTable.DataTable.Rows.Count ; nRow++ )
			{
				if( oTable.DataTable.Rows[ nRow ][ 1 ].GetType() != typeof( System.DBNull ) )
				{
					naBorders[ nRow,0 ]	= (int)oTable.DataTable.Rows[ nRow ][ 1 ];
				}
				if( oTable.DataTable.Rows[ nRow ][ 2 ].GetType() != typeof( System.DBNull ) )
				{
					naBorders[ nRow,1 ]	= (int)oTable.DataTable.Rows[ nRow ][ 2 ];
				}
				if( oTable.DataTable.Rows[ nRow ][ 3 ].GetType() != typeof( System.DBNull ) )
				{
					naBorders[ nRow,2 ]	= (int)oTable.DataTable.Rows[ nRow ][ 3 ];
				}
				if( oTable.DataTable.Rows[ nRow ][ 4 ].GetType() != typeof( System.DBNull ) )
				{
					naBorders[ nRow,3 ] = (int)oTable.DataTable.Rows[ nRow ][ 4 ];
				}
			}
			UpdatePicture( oTable.File,picSpriteSheetPreview,lblSpriteSheetPicSize,naBorders );
		}


		private void cmdSpriteSheetPickColor_Click(object sender, System.EventArgs e)
		{
			dlgColor.ShowDialog();
			GetSelectedTable().AlphaColor = dlgColor.Color.ToArgb();
			txtSpriteSheetTransparencyColor.BackColor = dlgColor.Color;				
		}
		private void cmdRefreshSpriteSheet_Click(object sender, System.EventArgs e)
		{
			UpdateSpriteSheetPicture( GetSelectedTable() );
		}
		private void grdSpriteSheet_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			Bitmap oFilePic = null;
			int[] naBorders = new int[ 4 ];
			DSGobTable oTable = GetSelectedTable();
			frmSpriteSheetZoom oZoom = null;
			System.Windows.Forms.DataGrid.HitTestInfo oInfo = grdSpriteSheet.HitTest( e.X,e.Y );
			TimeSpan oSpan = TimeSpan.MinValue;


			oSpan = DateTime.Now - m_dtLastGridClick;
			if( oSpan.TotalSeconds < .5 && oInfo.Row > -1 )
			{
				//Get our picture
				oFilePic = new Bitmap( oTable.File );
				//Find our row
				naBorders[ 0 ] = (int)oTable.DataTable.Rows[ oInfo.Row ][ 1 ];
				naBorders[ 1 ] = (int)oTable.DataTable.Rows[ oInfo.Row ][ 2 ];
				naBorders[ 2 ] = (int)oTable.DataTable.Rows[ oInfo.Row ][ 3 ];
				naBorders[ 3 ] = (int)oTable.DataTable.Rows[ oInfo.Row ][ 4 ];

				//Launch the zoom
				oZoom = new frmSpriteSheetZoom();
				oZoom.Setup( oFilePic,naBorders );
				oZoom.ShowDialog();
 
				//Retreive our values
				oTable.DataTable.Rows[ oInfo.Row ][ 1 ] = oZoom.Borders[ 0 ];
				oTable.DataTable.Rows[ oInfo.Row ][ 2 ] = oZoom.Borders[ 1 ];
				oTable.DataTable.Rows[ oInfo.Row ][ 3 ] = oZoom.Borders[ 2 ];
				oTable.DataTable.Rows[ oInfo.Row ][ 4 ] = oZoom.Borders[ 3 ];

				//Now populate the picture if its a graphic
				UpdateSpriteSheetPicture( oTable );
			}

			m_dtLastGridClick = DateTime.Now;
		}
		#endregion
	}

	public class UpdatePicThread
	{
		#region Variables
		private System.IO.MemoryStream m_oStream = null;
		private PictureBox m_oPictureBox = null;
		private Label m_oSizeLabel = null;
		private int[,] m_naBorders = null;
		private ListBox m_oListBoxErrors = null;

		private Thread m_oWorker = null;
		#endregion
		#region Delegates
		public delegate void AddErrorDelegate( string sError );
		public delegate void ClearErrorsDelegate();
		public delegate void SetPicWidthHeightDelegate( int nWidth,int nHeight );
		public delegate void SetVisibilityDelegate( System.Windows.Forms.Control oControl,bool bVisible );
		public delegate void SetPictureBoxDelegate( PictureBox oPictureBox,Bitmap oFilePic );
		#endregion

		public UpdatePicThread( ListBox oListBoxErrors,System.IO.MemoryStream oStream,PictureBox oPictureBox,Label oSizeLabel,int[,] naBorders )
		{
			m_oStream = oStream;
			m_oPictureBox = oPictureBox;
			m_oSizeLabel = oSizeLabel;
			m_naBorders = naBorders;
			m_oListBoxErrors = oListBoxErrors;

			m_oWorker = new Thread( new ThreadStart( UpdatePictureThread ) );
			m_oWorker.IsBackground = true;
			m_oWorker.Start();
		}

		private void UpdatePictureThread()
		{
			int nWidth = 0, nHeight = 0;
			int nLeft = 0, nTop = 0;
			Bitmap oFilePic = null;


			try
			{
				ClearErrors();
				SetVisibility( m_oSizeLabel,false );

				if( m_oStream != null )
				{
					try
					{
						oFilePic = new Bitmap( m_oStream );
						m_oSizeLabel.Text = "Picture Size: (" + oFilePic.Width.ToString() + "," + oFilePic.Height.ToString() + ")";

						if( oFilePic.Width > 2048 || oFilePic.Height > 2048 )
						{
							AddError( "Graphic's dimensions are greater than 2048" );
						}
						if( oFilePic.Width != oFilePic.Height )
						{
							AddError( "Graphic's dimensions are not square" );
						}
						if( DSMath.IsPowerOf2( oFilePic.Width ) == false || DSMath.IsPowerOf2( oFilePic.Height ) == false )
						{
							AddError( "Graphic's dimensions are not powers of 2" );
						}


						//Format our bitmap properly
						oFilePic = Globals.ConvertIndexedToRGBBitMap( oFilePic );


						//Go through and render squares around the sub-sprites
						for( int nRow=0 ; nRow<m_naBorders.GetLongLength( 0 ) ; nRow++ )
						{
							nLeft	= m_naBorders[ nRow,0 ];
							nTop	= m_naBorders[ nRow,1 ];
							nWidth	= m_naBorders[ nRow,2 ];
							nHeight = m_naBorders[ nRow,3 ];

							if( nWidth > 0 && nHeight > 0 )
							{
								for( int nX=-1 ; nX<nWidth+1 ; nX++ )
								{
									if( nLeft+nX < oFilePic.Width && nLeft+nX >= 0 )
									{
										if( nTop-1 < oFilePic.Height && nTop-1 >= 0 )
										{
											oFilePic.SetPixel( nLeft+nX,nTop-1,System.Drawing.Color.Red );
										}
										if( nTop+nHeight+1 < oFilePic.Height && nTop+nHeight+1 >= 0 )
										{
											oFilePic.SetPixel( nLeft+nX,nTop+nHeight+1,System.Drawing.Color.Red );
										}
									}
								}
								for( int nY=-1 ; nY<nHeight+1 ; nY++ )
								{
									if( nTop+nY < oFilePic.Height && nTop+nY >= 0 )
									{
										if( nLeft-1 < oFilePic.Width && nLeft-1 >= 0 )
										{
											oFilePic.SetPixel( nLeft-1,nTop+nY,System.Drawing.Color.Red );
										}
										if( nLeft+nWidth+1 < oFilePic.Width && nLeft+nWidth+1 >= 0 )
										{
											oFilePic.SetPixel( nLeft+nWidth+1,nTop+nY,System.Drawing.Color.Red );
										}
									}
								}
							}
						}
					}
					catch
					{
						oFilePic = null;
					}
				}

				//We have to do this here in case the loading failed
				if( oFilePic != null )
				{
					SetVisibility( m_oSizeLabel,true );
					SetPicWidthHeight( oFilePic.Width,oFilePic.Height );
				}
				else
				{
					SetVisibility( m_oSizeLabel,false );
					SetPicWidthHeight( m_oPictureBox.Parent.Width,m_oPictureBox.Parent.Height );
				}

				SetPictureBox( m_oPictureBox,oFilePic );
			}
			catch( System.Exception oEx )
			{
				DSMisc.ShowErrors( oEx );
			}
		}


		#region Delegate Calls
		private void AddError( string sError )
		{
			if( m_oListBoxErrors.InvokeRequired == true )
			{
				m_oListBoxErrors.BeginInvoke( new AddErrorDelegate(AddError),new object[]{ sError } );
			}
			else
			{
				m_oListBoxErrors.Items.Add( sError );
			}
		}

		private void ClearErrors()
		{
			if( m_oListBoxErrors.InvokeRequired == true )
			{
				m_oListBoxErrors.BeginInvoke( new ClearErrorsDelegate(ClearErrors),new object[]{} );
			}
			else
			{
				m_oListBoxErrors.Items.Clear();
			}
		}
		private void SetPicWidthHeight( int nWidth,int nHeight )
		{
			if( m_oPictureBox.InvokeRequired == true )
			{
				m_oPictureBox.BeginInvoke( new SetPicWidthHeightDelegate(SetPicWidthHeight),
											new object[]{ nWidth,nHeight } );
			}
			else
			{
				m_oPictureBox.Width = nWidth;
				m_oPictureBox.Height = nHeight;
			}
		}
		private void SetVisibility( System.Windows.Forms.Control oControl,bool bVisible )
		{
			if( oControl.InvokeRequired == true )
			{
				oControl.BeginInvoke( new SetVisibilityDelegate(SetVisibility),
					new object[]{ oControl,bVisible } );
			}
			else
			{
				oControl.Visible = bVisible;
			}			
		}
		private void SetPictureBox( PictureBox oPictureBox,Bitmap oFilePic )
		{
			if( oPictureBox.InvokeRequired == true )
			{
				oPictureBox.BeginInvoke( new SetPictureBoxDelegate(SetPictureBox),
					new object[]{ oPictureBox,oFilePic } );
			}
			else
			{
				oPictureBox.Image = oFilePic;
			}			
		}
		#endregion
	}
}