using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Microsoft.DirectX.Direct3D;

using DarkStrideToolbox;
using DarkStride.StellarLanes.SharedDLL;


namespace ShipBuilder
{
	public class frmMain : System.Windows.Forms.Form
	{
		#region Properties 
		private DSGobFile m_oGobFile = new DSGobFile();
		private DSGobTable m_oChassisTable = null;
		private DSGobTable m_oModuleTable = null;

		private string m_sCurrentModuleTypes = string.Empty;
		private int m_nLastChassisTypeAssigned = 0;

		private TreeNode m_oChassisNode = null;
		private TreeNode m_oNewChassisNode = null;		
		private TreeNode m_oModuleNode = null;
		private TreeNode m_oNewModuleNode = null;		
		#endregion

		#region System Stuff
		private System.Windows.Forms.TreeView treItems;
		private System.Windows.Forms.Panel pnlChassis;
		private System.Windows.Forms.TabControl tabControl1;
		private System.Windows.Forms.TabPage tbpNormal;
		private System.Windows.Forms.TextBox txtChassis_Normal_FixedRedux;
		private System.Windows.Forms.TextBox txtChassis_Normal_PercRedux;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.TextBox txtChassis_Normal_Structure;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox txtChassis_Normal_Mass;
		private System.Windows.Forms.TabPage tbpAdvanced;
		private System.Windows.Forms.TabPage tbpExpert;
		private System.Windows.Forms.TextBox txtChassis_Advanced_FixedRedux;
		private System.Windows.Forms.TextBox txtChassis_Advanced_PercRedux;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.TextBox txtChassis_Advanced_Structure;
		private System.Windows.Forms.Label label11;
		private System.Windows.Forms.Label label12;
		private System.Windows.Forms.TextBox txtChassis_Advanced_Mass;
		private System.Windows.Forms.TextBox txtChassis_Expert_FixedRedux;
		private System.Windows.Forms.TextBox txtChassis_Expert_PercRedux;
		private System.Windows.Forms.Label label13;
		private System.Windows.Forms.Label label14;
		private System.Windows.Forms.TextBox txtChassis_Expert_Structure;
		private System.Windows.Forms.Label label15;
		private System.Windows.Forms.Label label16;
		private System.Windows.Forms.TextBox txtChassis_Expert_Mass;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox txtChassis_Normal_Name;
		private System.Windows.Forms.Label label17;
		private System.Windows.Forms.TextBox txtChassis_Advanced_Name;
		private System.Windows.Forms.Label label18;
		private System.Windows.Forms.TextBox txtChassis_Expert_Name;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem mnuFile;
		private System.Windows.Forms.MenuItem mnuFile_Save;
		private System.Windows.Forms.MenuItem mnuFile_Exit;
		private System.Windows.Forms.Panel pnlModule;
		private System.Windows.Forms.TabControl tabControl2;
		private System.Windows.Forms.TabPage tabPage1;
		private System.Windows.Forms.TabPage tabPage2;
		private System.Windows.Forms.TabPage tabPage3;
		private ShipBuilder.ctlModuleProperties ctlModuleProperties_Nrm;
		private ShipBuilder.ctlModuleProperties ctlModuleProperties_Adv;
		private ShipBuilder.ctlModuleProperties ctlModuleProperties_Exp;
		private System.Windows.Forms.Panel pnlGeneral;
		private System.Windows.Forms.Panel pnlGraphic;
		private System.Windows.Forms.PictureBox picChassis;
		private System.Windows.Forms.Label label19;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.ComboBox cboTextureKey;
		private System.Windows.Forms.Label lblTextureKey;
		private System.Windows.Forms.TextBox txtHeight;
		private System.Windows.Forms.TextBox txtWidth;
		private System.Windows.Forms.CheckBox chkShowInSpace;
		private System.Windows.Forms.TextBox txtChassis_Normal_MinLevel;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TextBox txtChassis_Advanced_MinLevel;
		private System.Windows.Forms.Label label20;
		private System.Windows.Forms.TextBox txtChassis_Expert_MinLevel;
        private System.Windows.Forms.Label label21;
        private IContainer components;

		public frmMain()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            this.treItems = new System.Windows.Forms.TreeView();
            this.pnlChassis = new System.Windows.Forms.Panel();
            this.tabControl1 = new System.Windows.Forms.TabControl();
            this.tbpNormal = new System.Windows.Forms.TabPage();
            this.txtChassis_Normal_MinLevel = new System.Windows.Forms.TextBox();
            this.label3 = new System.Windows.Forms.Label();
            this.label1 = new System.Windows.Forms.Label();
            this.txtChassis_Normal_Name = new System.Windows.Forms.TextBox();
            this.txtChassis_Normal_FixedRedux = new System.Windows.Forms.TextBox();
            this.txtChassis_Normal_PercRedux = new System.Windows.Forms.TextBox();
            this.label6 = new System.Windows.Forms.Label();
            this.label5 = new System.Windows.Forms.Label();
            this.txtChassis_Normal_Structure = new System.Windows.Forms.TextBox();
            this.label4 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.txtChassis_Normal_Mass = new System.Windows.Forms.TextBox();
            this.tbpAdvanced = new System.Windows.Forms.TabPage();
            this.txtChassis_Advanced_MinLevel = new System.Windows.Forms.TextBox();
            this.label20 = new System.Windows.Forms.Label();
            this.label17 = new System.Windows.Forms.Label();
            this.txtChassis_Advanced_Name = new System.Windows.Forms.TextBox();
            this.txtChassis_Advanced_FixedRedux = new System.Windows.Forms.TextBox();
            this.txtChassis_Advanced_PercRedux = new System.Windows.Forms.TextBox();
            this.label9 = new System.Windows.Forms.Label();
            this.label10 = new System.Windows.Forms.Label();
            this.txtChassis_Advanced_Structure = new System.Windows.Forms.TextBox();
            this.label11 = new System.Windows.Forms.Label();
            this.label12 = new System.Windows.Forms.Label();
            this.txtChassis_Advanced_Mass = new System.Windows.Forms.TextBox();
            this.tbpExpert = new System.Windows.Forms.TabPage();
            this.txtChassis_Expert_MinLevel = new System.Windows.Forms.TextBox();
            this.label21 = new System.Windows.Forms.Label();
            this.label18 = new System.Windows.Forms.Label();
            this.txtChassis_Expert_Name = new System.Windows.Forms.TextBox();
            this.txtChassis_Expert_FixedRedux = new System.Windows.Forms.TextBox();
            this.txtChassis_Expert_PercRedux = new System.Windows.Forms.TextBox();
            this.label13 = new System.Windows.Forms.Label();
            this.label14 = new System.Windows.Forms.Label();
            this.txtChassis_Expert_Structure = new System.Windows.Forms.TextBox();
            this.label15 = new System.Windows.Forms.Label();
            this.label16 = new System.Windows.Forms.Label();
            this.txtChassis_Expert_Mass = new System.Windows.Forms.TextBox();
            this.mainMenu1 = new System.Windows.Forms.MainMenu(this.components);
            this.mnuFile = new System.Windows.Forms.MenuItem();
            this.mnuFile_Save = new System.Windows.Forms.MenuItem();
            this.mnuFile_Exit = new System.Windows.Forms.MenuItem();
            this.pnlModule = new System.Windows.Forms.Panel();
            this.tabControl2 = new System.Windows.Forms.TabControl();
            this.tabPage1 = new System.Windows.Forms.TabPage();
            this.tabPage2 = new System.Windows.Forms.TabPage();
            this.tabPage3 = new System.Windows.Forms.TabPage();
            this.pnlGeneral = new System.Windows.Forms.Panel();
            this.chkShowInSpace = new System.Windows.Forms.CheckBox();
            this.cboTextureKey = new System.Windows.Forms.ComboBox();
            this.lblTextureKey = new System.Windows.Forms.Label();
            this.pnlGraphic = new System.Windows.Forms.Panel();
            this.picChassis = new System.Windows.Forms.PictureBox();
            this.label19 = new System.Windows.Forms.Label();
            this.txtHeight = new System.Windows.Forms.TextBox();
            this.label8 = new System.Windows.Forms.Label();
            this.txtWidth = new System.Windows.Forms.TextBox();
            this.label7 = new System.Windows.Forms.Label();
            this.ctlModuleProperties_Nrm = new ShipBuilder.ctlModuleProperties();
            this.ctlModuleProperties_Adv = new ShipBuilder.ctlModuleProperties();
            this.ctlModuleProperties_Exp = new ShipBuilder.ctlModuleProperties();
            this.pnlChassis.SuspendLayout();
            this.tabControl1.SuspendLayout();
            this.tbpNormal.SuspendLayout();
            this.tbpAdvanced.SuspendLayout();
            this.tbpExpert.SuspendLayout();
            this.pnlModule.SuspendLayout();
            this.tabControl2.SuspendLayout();
            this.tabPage1.SuspendLayout();
            this.tabPage2.SuspendLayout();
            this.tabPage3.SuspendLayout();
            this.pnlGeneral.SuspendLayout();
            this.pnlGraphic.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.picChassis)).BeginInit();
            this.SuspendLayout();
            // 
            // treItems
            // 
            this.treItems.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                        | System.Windows.Forms.AnchorStyles.Left)));
            this.treItems.Location = new System.Drawing.Point(8, 0);
            this.treItems.Name = "treItems";
            this.treItems.Size = new System.Drawing.Size(176, 452);
            this.treItems.TabIndex = 0;
            this.treItems.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.treItems_AfterSelect);
            this.treItems.BeforeSelect += new System.Windows.Forms.TreeViewCancelEventHandler(this.treItems_BeforeSelect);
            // 
            // pnlChassis
            // 
            this.pnlChassis.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.pnlChassis.Controls.Add(this.tabControl1);
            this.pnlChassis.Location = new System.Drawing.Point(192, 0);
            this.pnlChassis.Name = "pnlChassis";
            this.pnlChassis.Size = new System.Drawing.Size(368, 184);
            this.pnlChassis.TabIndex = 3;
            this.pnlChassis.Visible = false;
            // 
            // tabControl1
            // 
            this.tabControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                        | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.tabControl1.Controls.Add(this.tbpNormal);
            this.tabControl1.Controls.Add(this.tbpAdvanced);
            this.tabControl1.Controls.Add(this.tbpExpert);
            this.tabControl1.Location = new System.Drawing.Point(0, 0);
            this.tabControl1.Name = "tabControl1";
            this.tabControl1.SelectedIndex = 0;
            this.tabControl1.Size = new System.Drawing.Size(368, 184);
            this.tabControl1.TabIndex = 24;
            // 
            // tbpNormal
            // 
            this.tbpNormal.Controls.Add(this.txtChassis_Normal_MinLevel);
            this.tbpNormal.Controls.Add(this.label3);
            this.tbpNormal.Controls.Add(this.label1);
            this.tbpNormal.Controls.Add(this.txtChassis_Normal_Name);
            this.tbpNormal.Controls.Add(this.txtChassis_Normal_FixedRedux);
            this.tbpNormal.Controls.Add(this.txtChassis_Normal_PercRedux);
            this.tbpNormal.Controls.Add(this.label6);
            this.tbpNormal.Controls.Add(this.label5);
            this.tbpNormal.Controls.Add(this.txtChassis_Normal_Structure);
            this.tbpNormal.Controls.Add(this.label4);
            this.tbpNormal.Controls.Add(this.label2);
            this.tbpNormal.Controls.Add(this.txtChassis_Normal_Mass);
            this.tbpNormal.Location = new System.Drawing.Point(4, 22);
            this.tbpNormal.Name = "tbpNormal";
            this.tbpNormal.Size = new System.Drawing.Size(360, 158);
            this.tbpNormal.TabIndex = 0;
            this.tbpNormal.Text = "Normal";
            // 
            // txtChassis_Normal_MinLevel
            // 
            this.txtChassis_Normal_MinLevel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.txtChassis_Normal_MinLevel.Location = new System.Drawing.Point(128, 32);
            this.txtChassis_Normal_MinLevel.Name = "txtChassis_Normal_MinLevel";
            this.txtChassis_Normal_MinLevel.Size = new System.Drawing.Size(104, 20);
            this.txtChassis_Normal_MinLevel.TabIndex = 25;
            // 
            // label3
            // 
            this.label3.Location = new System.Drawing.Point(16, 32);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(104, 16);
            this.label3.TabIndex = 26;
            this.label3.Text = "Min Level To Use:";
            this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // label1
            // 
            this.label1.AutoSize = true;
            this.label1.Location = new System.Drawing.Point(8, 8);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(38, 13);
            this.label1.TabIndex = 24;
            this.label1.Text = "Name:";
            // 
            // txtChassis_Normal_Name
            // 
            this.txtChassis_Normal_Name.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.txtChassis_Normal_Name.Location = new System.Drawing.Point(48, 8);
            this.txtChassis_Normal_Name.Name = "txtChassis_Normal_Name";
            this.txtChassis_Normal_Name.Size = new System.Drawing.Size(304, 20);
            this.txtChassis_Normal_Name.TabIndex = 23;
            this.txtChassis_Normal_Name.TextChanged += new System.EventHandler(this.txtChassis_Normal_Name_TextChanged);
            // 
            // txtChassis_Normal_FixedRedux
            // 
            this.txtChassis_Normal_FixedRedux.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.txtChassis_Normal_FixedRedux.Location = new System.Drawing.Point(128, 80);
            this.txtChassis_Normal_FixedRedux.Name = "txtChassis_Normal_FixedRedux";
            this.txtChassis_Normal_FixedRedux.Size = new System.Drawing.Size(104, 20);
            this.txtChassis_Normal_FixedRedux.TabIndex = 19;
            // 
            // txtChassis_Normal_PercRedux
            // 
            this.txtChassis_Normal_PercRedux.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.txtChassis_Normal_PercRedux.Location = new System.Drawing.Point(128, 128);
            this.txtChassis_Normal_PercRedux.Name = "txtChassis_Normal_PercRedux";
            this.txtChassis_Normal_PercRedux.Size = new System.Drawing.Size(104, 20);
            this.txtChassis_Normal_PercRedux.TabIndex = 21;
            // 
            // label6
            // 
            this.label6.Location = new System.Drawing.Point(24, 128);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(96, 16);
            this.label6.TabIndex = 22;
            this.label6.Text = "% Dmg Redux:";
            this.label6.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // label5
            // 
            this.label5.Location = new System.Drawing.Point(8, 80);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(112, 16);
            this.label5.TabIndex = 20;
            this.label5.Text = "Fixed Dmg Redux:";
            this.label5.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // txtChassis_Normal_Structure
            // 
            this.txtChassis_Normal_Structure.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.txtChassis_Normal_Structure.Location = new System.Drawing.Point(128, 56);
            this.txtChassis_Normal_Structure.Name = "txtChassis_Normal_Structure";
            this.txtChassis_Normal_Structure.Size = new System.Drawing.Size(104, 20);
            this.txtChassis_Normal_Structure.TabIndex = 17;
            // 
            // label4
            // 
            this.label4.Location = new System.Drawing.Point(16, 56);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(104, 16);
            this.label4.TabIndex = 18;
            this.label4.Text = "Structure Pts.:";
            this.label4.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(48, 104);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(72, 16);
            this.label2.TabIndex = 16;
            this.label2.Text = "Mass:";
            this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // txtChassis_Normal_Mass
            // 
            this.txtChassis_Normal_Mass.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.txtChassis_Normal_Mass.Location = new System.Drawing.Point(128, 104);
            this.txtChassis_Normal_Mass.Name = "txtChassis_Normal_Mass";
            this.txtChassis_Normal_Mass.Size = new System.Drawing.Size(104, 20);
            this.txtChassis_Normal_Mass.TabIndex = 15;
            // 
            // tbpAdvanced
            // 
            this.tbpAdvanced.Controls.Add(this.txtChassis_Advanced_MinLevel);
            this.tbpAdvanced.Controls.Add(this.label20);
            this.tbpAdvanced.Controls.Add(this.label17);
            this.tbpAdvanced.Controls.Add(this.txtChassis_Advanced_Name);
            this.tbpAdvanced.Controls.Add(this.txtChassis_Advanced_FixedRedux);
            this.tbpAdvanced.Controls.Add(this.txtChassis_Advanced_PercRedux);
            this.tbpAdvanced.Controls.Add(this.label9);
            this.tbpAdvanced.Controls.Add(this.label10);
            this.tbpAdvanced.Controls.Add(this.txtChassis_Advanced_Structure);
            this.tbpAdvanced.Controls.Add(this.label11);
            this.tbpAdvanced.Controls.Add(this.label12);
            this.tbpAdvanced.Controls.Add(this.txtChassis_Advanced_Mass);
            this.tbpAdvanced.Location = new System.Drawing.Point(4, 22);
            this.tbpAdvanced.Name = "tbpAdvanced";
            this.tbpAdvanced.Size = new System.Drawing.Size(360, 158);
            this.tbpAdvanced.TabIndex = 1;
            this.tbpAdvanced.Text = "Advanced";
            // 
            // txtChassis_Advanced_MinLevel
            // 
            this.txtChassis_Advanced_MinLevel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.txtChassis_Advanced_MinLevel.Location = new System.Drawing.Point(128, 32);
            this.txtChassis_Advanced_MinLevel.Name = "txtChassis_Advanced_MinLevel";
            this.txtChassis_Advanced_MinLevel.Size = new System.Drawing.Size(104, 20);
            this.txtChassis_Advanced_MinLevel.TabIndex = 33;
            // 
            // label20
            // 
            this.label20.Location = new System.Drawing.Point(16, 32);
            this.label20.Name = "label20";
            this.label20.Size = new System.Drawing.Size(104, 16);
            this.label20.TabIndex = 34;
            this.label20.Text = "Min Level To Use:";
            this.label20.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // label17
            // 
            this.label17.AutoSize = true;
            this.label17.Location = new System.Drawing.Point(8, 8);
            this.label17.Name = "label17";
            this.label17.Size = new System.Drawing.Size(38, 13);
            this.label17.TabIndex = 32;
            this.label17.Text = "Name:";
            // 
            // txtChassis_Advanced_Name
            // 
            this.txtChassis_Advanced_Name.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.txtChassis_Advanced_Name.Location = new System.Drawing.Point(48, 8);
            this.txtChassis_Advanced_Name.Name = "txtChassis_Advanced_Name";
            this.txtChassis_Advanced_Name.Size = new System.Drawing.Size(304, 20);
            this.txtChassis_Advanced_Name.TabIndex = 31;
            // 
            // txtChassis_Advanced_FixedRedux
            // 
            this.txtChassis_Advanced_FixedRedux.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.txtChassis_Advanced_FixedRedux.Location = new System.Drawing.Point(128, 80);
            this.txtChassis_Advanced_FixedRedux.Name = "txtChassis_Advanced_FixedRedux";
            this.txtChassis_Advanced_FixedRedux.Size = new System.Drawing.Size(104, 20);
            this.txtChassis_Advanced_FixedRedux.TabIndex = 27;
            // 
            // txtChassis_Advanced_PercRedux
            // 
            this.txtChassis_Advanced_PercRedux.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.txtChassis_Advanced_PercRedux.Location = new System.Drawing.Point(128, 128);
            this.txtChassis_Advanced_PercRedux.Name = "txtChassis_Advanced_PercRedux";
            this.txtChassis_Advanced_PercRedux.Size = new System.Drawing.Size(104, 20);
            this.txtChassis_Advanced_PercRedux.TabIndex = 29;
            // 
            // label9
            // 
            this.label9.Location = new System.Drawing.Point(24, 128);
            this.label9.Name = "label9";
            this.label9.Size = new System.Drawing.Size(96, 16);
            this.label9.TabIndex = 30;
            this.label9.Text = "% Dmg Redux:";
            this.label9.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // label10
            // 
            this.label10.Location = new System.Drawing.Point(8, 80);
            this.label10.Name = "label10";
            this.label10.Size = new System.Drawing.Size(112, 16);
            this.label10.TabIndex = 28;
            this.label10.Text = "Fixed Dmg Redux:";
            this.label10.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // txtChassis_Advanced_Structure
            // 
            this.txtChassis_Advanced_Structure.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.txtChassis_Advanced_Structure.Location = new System.Drawing.Point(128, 56);
            this.txtChassis_Advanced_Structure.Name = "txtChassis_Advanced_Structure";
            this.txtChassis_Advanced_Structure.Size = new System.Drawing.Size(104, 20);
            this.txtChassis_Advanced_Structure.TabIndex = 25;
            // 
            // label11
            // 
            this.label11.Location = new System.Drawing.Point(16, 56);
            this.label11.Name = "label11";
            this.label11.Size = new System.Drawing.Size(104, 16);
            this.label11.TabIndex = 26;
            this.label11.Text = "Structure Pts.:";
            this.label11.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // label12
            // 
            this.label12.Location = new System.Drawing.Point(48, 104);
            this.label12.Name = "label12";
            this.label12.Size = new System.Drawing.Size(72, 16);
            this.label12.TabIndex = 24;
            this.label12.Text = "Mass:";
            this.label12.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // txtChassis_Advanced_Mass
            // 
            this.txtChassis_Advanced_Mass.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.txtChassis_Advanced_Mass.Location = new System.Drawing.Point(128, 104);
            this.txtChassis_Advanced_Mass.Name = "txtChassis_Advanced_Mass";
            this.txtChassis_Advanced_Mass.Size = new System.Drawing.Size(104, 20);
            this.txtChassis_Advanced_Mass.TabIndex = 23;
            // 
            // tbpExpert
            // 
            this.tbpExpert.Controls.Add(this.txtChassis_Expert_MinLevel);
            this.tbpExpert.Controls.Add(this.label21);
            this.tbpExpert.Controls.Add(this.label18);
            this.tbpExpert.Controls.Add(this.txtChassis_Expert_Name);
            this.tbpExpert.Controls.Add(this.txtChassis_Expert_FixedRedux);
            this.tbpExpert.Controls.Add(this.txtChassis_Expert_PercRedux);
            this.tbpExpert.Controls.Add(this.label13);
            this.tbpExpert.Controls.Add(this.label14);
            this.tbpExpert.Controls.Add(this.txtChassis_Expert_Structure);
            this.tbpExpert.Controls.Add(this.label15);
            this.tbpExpert.Controls.Add(this.label16);
            this.tbpExpert.Controls.Add(this.txtChassis_Expert_Mass);
            this.tbpExpert.Location = new System.Drawing.Point(4, 22);
            this.tbpExpert.Name = "tbpExpert";
            this.tbpExpert.Size = new System.Drawing.Size(360, 158);
            this.tbpExpert.TabIndex = 2;
            this.tbpExpert.Text = "Expert";
            // 
            // txtChassis_Expert_MinLevel
            // 
            this.txtChassis_Expert_MinLevel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.txtChassis_Expert_MinLevel.Location = new System.Drawing.Point(128, 32);
            this.txtChassis_Expert_MinLevel.Name = "txtChassis_Expert_MinLevel";
            this.txtChassis_Expert_MinLevel.Size = new System.Drawing.Size(104, 20);
            this.txtChassis_Expert_MinLevel.TabIndex = 41;
            // 
            // label21
            // 
            this.label21.Location = new System.Drawing.Point(16, 32);
            this.label21.Name = "label21";
            this.label21.Size = new System.Drawing.Size(104, 16);
            this.label21.TabIndex = 42;
            this.label21.Text = "Min Level To Use:";
            this.label21.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // label18
            // 
            this.label18.AutoSize = true;
            this.label18.Location = new System.Drawing.Point(8, 8);
            this.label18.Name = "label18";
            this.label18.Size = new System.Drawing.Size(38, 13);
            this.label18.TabIndex = 40;
            this.label18.Text = "Name:";
            // 
            // txtChassis_Expert_Name
            // 
            this.txtChassis_Expert_Name.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.txtChassis_Expert_Name.Location = new System.Drawing.Point(48, 8);
            this.txtChassis_Expert_Name.Name = "txtChassis_Expert_Name";
            this.txtChassis_Expert_Name.Size = new System.Drawing.Size(304, 20);
            this.txtChassis_Expert_Name.TabIndex = 39;
            // 
            // txtChassis_Expert_FixedRedux
            // 
            this.txtChassis_Expert_FixedRedux.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.txtChassis_Expert_FixedRedux.Location = new System.Drawing.Point(128, 80);
            this.txtChassis_Expert_FixedRedux.Name = "txtChassis_Expert_FixedRedux";
            this.txtChassis_Expert_FixedRedux.Size = new System.Drawing.Size(104, 20);
            this.txtChassis_Expert_FixedRedux.TabIndex = 35;
            // 
            // txtChassis_Expert_PercRedux
            // 
            this.txtChassis_Expert_PercRedux.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.txtChassis_Expert_PercRedux.Location = new System.Drawing.Point(128, 128);
            this.txtChassis_Expert_PercRedux.Name = "txtChassis_Expert_PercRedux";
            this.txtChassis_Expert_PercRedux.Size = new System.Drawing.Size(104, 20);
            this.txtChassis_Expert_PercRedux.TabIndex = 37;
            // 
            // label13
            // 
            this.label13.Location = new System.Drawing.Point(24, 128);
            this.label13.Name = "label13";
            this.label13.Size = new System.Drawing.Size(96, 16);
            this.label13.TabIndex = 38;
            this.label13.Text = "% Dmg Redux:";
            this.label13.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // label14
            // 
            this.label14.Location = new System.Drawing.Point(8, 80);
            this.label14.Name = "label14";
            this.label14.Size = new System.Drawing.Size(112, 16);
            this.label14.TabIndex = 36;
            this.label14.Text = "Fixed Dmg Redux:";
            this.label14.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // txtChassis_Expert_Structure
            // 
            this.txtChassis_Expert_Structure.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.txtChassis_Expert_Structure.Location = new System.Drawing.Point(128, 56);
            this.txtChassis_Expert_Structure.Name = "txtChassis_Expert_Structure";
            this.txtChassis_Expert_Structure.Size = new System.Drawing.Size(104, 20);
            this.txtChassis_Expert_Structure.TabIndex = 33;
            // 
            // label15
            // 
            this.label15.Location = new System.Drawing.Point(16, 56);
            this.label15.Name = "label15";
            this.label15.Size = new System.Drawing.Size(104, 16);
            this.label15.TabIndex = 34;
            this.label15.Text = "Structure Pts.:";
            this.label15.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // label16
            // 
            this.label16.Location = new System.Drawing.Point(48, 104);
            this.label16.Name = "label16";
            this.label16.Size = new System.Drawing.Size(72, 16);
            this.label16.TabIndex = 32;
            this.label16.Text = "Mass:";
            this.label16.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // txtChassis_Expert_Mass
            // 
            this.txtChassis_Expert_Mass.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.txtChassis_Expert_Mass.Location = new System.Drawing.Point(128, 104);
            this.txtChassis_Expert_Mass.Name = "txtChassis_Expert_Mass";
            this.txtChassis_Expert_Mass.Size = new System.Drawing.Size(104, 20);
            this.txtChassis_Expert_Mass.TabIndex = 31;
            // 
            // mainMenu1
            // 
            this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnuFile});
            // 
            // mnuFile
            // 
            this.mnuFile.Index = 0;
            this.mnuFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnuFile_Save,
            this.mnuFile_Exit});
            this.mnuFile.Text = "&File";
            // 
            // mnuFile_Save
            // 
            this.mnuFile_Save.Index = 0;
            this.mnuFile_Save.Text = "&Save";
            this.mnuFile_Save.Click += new System.EventHandler(this.mnuFile_Save_Click);
            // 
            // mnuFile_Exit
            // 
            this.mnuFile_Exit.Index = 1;
            this.mnuFile_Exit.Text = "E&xit";
            this.mnuFile_Exit.Click += new System.EventHandler(this.mnuFile_Exit_Click);
            // 
            // pnlModule
            // 
            this.pnlModule.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.pnlModule.Controls.Add(this.tabControl2);
            this.pnlModule.Location = new System.Drawing.Point(192, 0);
            this.pnlModule.Name = "pnlModule";
            this.pnlModule.Size = new System.Drawing.Size(368, 280);
            this.pnlModule.TabIndex = 17;
            this.pnlModule.Visible = false;
            // 
            // tabControl2
            // 
            this.tabControl2.Controls.Add(this.tabPage1);
            this.tabControl2.Controls.Add(this.tabPage2);
            this.tabControl2.Controls.Add(this.tabPage3);
            this.tabControl2.Dock = System.Windows.Forms.DockStyle.Fill;
            this.tabControl2.Location = new System.Drawing.Point(0, 0);
            this.tabControl2.Name = "tabControl2";
            this.tabControl2.SelectedIndex = 0;
            this.tabControl2.Size = new System.Drawing.Size(368, 280);
            this.tabControl2.TabIndex = 24;
            // 
            // tabPage1
            // 
            this.tabPage1.Controls.Add(this.ctlModuleProperties_Nrm);
            this.tabPage1.Location = new System.Drawing.Point(4, 22);
            this.tabPage1.Name = "tabPage1";
            this.tabPage1.Size = new System.Drawing.Size(360, 254);
            this.tabPage1.TabIndex = 0;
            this.tabPage1.Text = "Normal";
            // 
            // tabPage2
            // 
            this.tabPage2.Controls.Add(this.ctlModuleProperties_Adv);
            this.tabPage2.Location = new System.Drawing.Point(4, 22);
            this.tabPage2.Name = "tabPage2";
            this.tabPage2.Size = new System.Drawing.Size(360, 254);
            this.tabPage2.TabIndex = 1;
            this.tabPage2.Text = "Advanced";
            this.tabPage2.Visible = false;
            // 
            // tabPage3
            // 
            this.tabPage3.Controls.Add(this.ctlModuleProperties_Exp);
            this.tabPage3.Location = new System.Drawing.Point(4, 22);
            this.tabPage3.Name = "tabPage3";
            this.tabPage3.Size = new System.Drawing.Size(360, 254);
            this.tabPage3.TabIndex = 2;
            this.tabPage3.Text = "Expert";
            this.tabPage3.Visible = false;
            // 
            // pnlGeneral
            // 
            this.pnlGeneral.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.pnlGeneral.Controls.Add(this.chkShowInSpace);
            this.pnlGeneral.Controls.Add(this.cboTextureKey);
            this.pnlGeneral.Controls.Add(this.lblTextureKey);
            this.pnlGeneral.Controls.Add(this.pnlGraphic);
            this.pnlGeneral.Controls.Add(this.label19);
            this.pnlGeneral.Controls.Add(this.txtHeight);
            this.pnlGeneral.Controls.Add(this.label8);
            this.pnlGeneral.Controls.Add(this.txtWidth);
            this.pnlGeneral.Controls.Add(this.label7);
            this.pnlGeneral.Location = new System.Drawing.Point(192, 288);
            this.pnlGeneral.Name = "pnlGeneral";
            this.pnlGeneral.Size = new System.Drawing.Size(368, 208);
            this.pnlGeneral.TabIndex = 18;
            // 
            // chkShowInSpace
            // 
            this.chkShowInSpace.Location = new System.Drawing.Point(240, 32);
            this.chkShowInSpace.Name = "chkShowInSpace";
            this.chkShowInSpace.Size = new System.Drawing.Size(104, 16);
            this.chkShowInSpace.TabIndex = 40;
            this.chkShowInSpace.Text = "Show In Space";
            // 
            // cboTextureKey
            // 
            this.cboTextureKey.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.cboTextureKey.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.cboTextureKey.Location = new System.Drawing.Point(72, 8);
            this.cboTextureKey.Name = "cboTextureKey";
            this.cboTextureKey.Size = new System.Drawing.Size(296, 21);
            this.cboTextureKey.Sorted = true;
            this.cboTextureKey.TabIndex = 39;
            this.cboTextureKey.SelectedIndexChanged += new System.EventHandler(this.cboTextureKey_SelectedIndexChanged);
            this.cboTextureKey.SelectedValueChanged += new System.EventHandler(this.cboTextureKey_SelectedIndexChanged);
            // 
            // lblTextureKey
            // 
            this.lblTextureKey.AutoSize = true;
            this.lblTextureKey.Location = new System.Drawing.Point(0, 16);
            this.lblTextureKey.Name = "lblTextureKey";
            this.lblTextureKey.Size = new System.Drawing.Size(67, 13);
            this.lblTextureKey.TabIndex = 38;
            this.lblTextureKey.Text = "Texture Key:";
            // 
            // pnlGraphic
            // 
            this.pnlGraphic.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                        | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.pnlGraphic.AutoScroll = true;
            this.pnlGraphic.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.pnlGraphic.Controls.Add(this.picChassis);
            this.pnlGraphic.Location = new System.Drawing.Point(0, 56);
            this.pnlGraphic.Name = "pnlGraphic";
            this.pnlGraphic.Size = new System.Drawing.Size(368, 136);
            this.pnlGraphic.TabIndex = 32;
            // 
            // picChassis
            // 
            this.picChassis.Location = new System.Drawing.Point(0, 0);
            this.picChassis.Name = "picChassis";
            this.picChassis.Size = new System.Drawing.Size(232, 152);
            this.picChassis.SizeMode = System.Windows.Forms.PictureBoxSizeMode.AutoSize;
            this.picChassis.TabIndex = 0;
            this.picChassis.TabStop = false;
            this.picChassis.MouseDown += new System.Windows.Forms.MouseEventHandler(this.picChassis_MouseDown);
            // 
            // label19
            // 
            this.label19.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
            this.label19.AutoSize = true;
            this.label19.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label19.ForeColor = System.Drawing.SystemColors.ControlDarkDark;
            this.label19.Location = new System.Drawing.Point(8, 192);
            this.label19.Name = "label19";
            this.label19.Size = new System.Drawing.Size(204, 13);
            this.label19.TabIndex = 37;
            this.label19.Text = "(Right-click to copy the last module setup)";
            // 
            // txtHeight
            // 
            this.txtHeight.Location = new System.Drawing.Point(160, 32);
            this.txtHeight.Name = "txtHeight";
            this.txtHeight.Size = new System.Drawing.Size(72, 20);
            this.txtHeight.TabIndex = 35;
            this.txtHeight.TextChanged += new System.EventHandler(this.txtPicSize_TextChanged);
            // 
            // label8
            // 
            this.label8.AutoSize = true;
            this.label8.Location = new System.Drawing.Point(120, 32);
            this.label8.Name = "label8";
            this.label8.Size = new System.Drawing.Size(41, 13);
            this.label8.TabIndex = 36;
            this.label8.Text = "Height:";
            // 
            // txtWidth
            // 
            this.txtWidth.Location = new System.Drawing.Point(40, 32);
            this.txtWidth.Name = "txtWidth";
            this.txtWidth.Size = new System.Drawing.Size(72, 20);
            this.txtWidth.TabIndex = 33;
            this.txtWidth.TextChanged += new System.EventHandler(this.txtPicSize_TextChanged);
            // 
            // label7
            // 
            this.label7.AutoSize = true;
            this.label7.Location = new System.Drawing.Point(0, 32);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(38, 13);
            this.label7.TabIndex = 34;
            this.label7.Text = "Width:";
            // 
            // ctlModuleProperties_Nrm
            // 
            this.ctlModuleProperties_Nrm.AttitudeThruster = false;
            this.ctlModuleProperties_Nrm.Battery_Max = 0;
            this.ctlModuleProperties_Nrm.Battery_Min = 0;
            this.ctlModuleProperties_Nrm.BatteryAbsorb_Max = 0;
            this.ctlModuleProperties_Nrm.BatteryAbsorb_Min = 0;
            this.ctlModuleProperties_Nrm.BatteryRelease_Max = 0;
            this.ctlModuleProperties_Nrm.BatteryRelease_Min = 0;
            this.ctlModuleProperties_Nrm.Consume_Max = 0;
            this.ctlModuleProperties_Nrm.Consume_Min = 0;
            this.ctlModuleProperties_Nrm.ConsumesEnergy = false;
            this.ctlModuleProperties_Nrm.Dock = System.Windows.Forms.DockStyle.Fill;
            this.ctlModuleProperties_Nrm.Generate_Max = 0;
            this.ctlModuleProperties_Nrm.Generate_Min = 0;
            this.ctlModuleProperties_Nrm.GeneratesEnergy = false;
            this.ctlModuleProperties_Nrm.GeneratesHUDLevel = false;
            this.ctlModuleProperties_Nrm.HUDLevel = -1;
            this.ctlModuleProperties_Nrm.LinearBreakThrust_Max = 0;
            this.ctlModuleProperties_Nrm.LinearBreakThrust_Min = 0;
            this.ctlModuleProperties_Nrm.LinearThrust_Max = 0;
            this.ctlModuleProperties_Nrm.LinearThrust_Min = 0;
            this.ctlModuleProperties_Nrm.LinearThrust_PSys = ((long)(-1));
            this.ctlModuleProperties_Nrm.LinearThruster = false;
            this.ctlModuleProperties_Nrm.Location = new System.Drawing.Point(0, 0);
            this.ctlModuleProperties_Nrm.MinLevel = ((long)(0));
            this.ctlModuleProperties_Nrm.ModuleName = "";
            this.ctlModuleProperties_Nrm.Name = "ctlModuleProperties_Nrm";
            this.ctlModuleProperties_Nrm.Size = new System.Drawing.Size(360, 254);
            this.ctlModuleProperties_Nrm.StoresEnergy = false;
            this.ctlModuleProperties_Nrm.TabIndex = 25;
            this.ctlModuleProperties_Nrm.TurningThrust_Max = 0;
            this.ctlModuleProperties_Nrm.TurningThrust_Min = 0;
            // 
            // ctlModuleProperties_Adv
            // 
            this.ctlModuleProperties_Adv.AttitudeThruster = false;
            this.ctlModuleProperties_Adv.Battery_Max = 0;
            this.ctlModuleProperties_Adv.Battery_Min = 0;
            this.ctlModuleProperties_Adv.BatteryAbsorb_Max = 0;
            this.ctlModuleProperties_Adv.BatteryAbsorb_Min = 0;
            this.ctlModuleProperties_Adv.BatteryRelease_Max = 0;
            this.ctlModuleProperties_Adv.BatteryRelease_Min = 0;
            this.ctlModuleProperties_Adv.Consume_Max = 0;
            this.ctlModuleProperties_Adv.Consume_Min = 0;
            this.ctlModuleProperties_Adv.ConsumesEnergy = false;
            this.ctlModuleProperties_Adv.Dock = System.Windows.Forms.DockStyle.Fill;
            this.ctlModuleProperties_Adv.Generate_Max = 0;
            this.ctlModuleProperties_Adv.Generate_Min = 0;
            this.ctlModuleProperties_Adv.GeneratesEnergy = false;
            this.ctlModuleProperties_Adv.GeneratesHUDLevel = false;
            this.ctlModuleProperties_Adv.HUDLevel = -1;
            this.ctlModuleProperties_Adv.LinearBreakThrust_Max = 0;
            this.ctlModuleProperties_Adv.LinearBreakThrust_Min = 0;
            this.ctlModuleProperties_Adv.LinearThrust_Max = 0;
            this.ctlModuleProperties_Adv.LinearThrust_Min = 0;
            this.ctlModuleProperties_Adv.LinearThrust_PSys = ((long)(-1));
            this.ctlModuleProperties_Adv.LinearThruster = false;
            this.ctlModuleProperties_Adv.Location = new System.Drawing.Point(0, 0);
            this.ctlModuleProperties_Adv.MinLevel = ((long)(0));
            this.ctlModuleProperties_Adv.ModuleName = "";
            this.ctlModuleProperties_Adv.Name = "ctlModuleProperties_Adv";
            this.ctlModuleProperties_Adv.Size = new System.Drawing.Size(360, 254);
            this.ctlModuleProperties_Adv.StoresEnergy = false;
            this.ctlModuleProperties_Adv.TabIndex = 33;
            this.ctlModuleProperties_Adv.TurningThrust_Max = 0;
            this.ctlModuleProperties_Adv.TurningThrust_Min = 0;
            // 
            // ctlModuleProperties_Exp
            // 
            this.ctlModuleProperties_Exp.AttitudeThruster = false;
            this.ctlModuleProperties_Exp.Battery_Max = 0;
            this.ctlModuleProperties_Exp.Battery_Min = 0;
            this.ctlModuleProperties_Exp.BatteryAbsorb_Max = 0;
            this.ctlModuleProperties_Exp.BatteryAbsorb_Min = 0;
            this.ctlModuleProperties_Exp.BatteryRelease_Max = 0;
            this.ctlModuleProperties_Exp.BatteryRelease_Min = 0;
            this.ctlModuleProperties_Exp.Consume_Max = 0;
            this.ctlModuleProperties_Exp.Consume_Min = 0;
            this.ctlModuleProperties_Exp.ConsumesEnergy = false;
            this.ctlModuleProperties_Exp.Dock = System.Windows.Forms.DockStyle.Fill;
            this.ctlModuleProperties_Exp.Generate_Max = 0;
            this.ctlModuleProperties_Exp.Generate_Min = 0;
            this.ctlModuleProperties_Exp.GeneratesEnergy = false;
            this.ctlModuleProperties_Exp.GeneratesHUDLevel = false;
            this.ctlModuleProperties_Exp.HUDLevel = -1;
            this.ctlModuleProperties_Exp.LinearBreakThrust_Max = 0;
            this.ctlModuleProperties_Exp.LinearBreakThrust_Min = 0;
            this.ctlModuleProperties_Exp.LinearThrust_Max = 0;
            this.ctlModuleProperties_Exp.LinearThrust_Min = 0;
            this.ctlModuleProperties_Exp.LinearThrust_PSys = ((long)(-1));
            this.ctlModuleProperties_Exp.LinearThruster = false;
            this.ctlModuleProperties_Exp.Location = new System.Drawing.Point(0, 0);
            this.ctlModuleProperties_Exp.MinLevel = ((long)(0));
            this.ctlModuleProperties_Exp.ModuleName = "";
            this.ctlModuleProperties_Exp.Name = "ctlModuleProperties_Exp";
            this.ctlModuleProperties_Exp.Size = new System.Drawing.Size(360, 254);
            this.ctlModuleProperties_Exp.StoresEnergy = false;
            this.ctlModuleProperties_Exp.TabIndex = 41;
            this.ctlModuleProperties_Exp.TurningThrust_Max = 0;
            this.ctlModuleProperties_Exp.TurningThrust_Min = 0;
            // 
            // frmMain
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(568, 457);
            this.Controls.Add(this.pnlChassis);
            this.Controls.Add(this.pnlModule);
            this.Controls.Add(this.pnlGeneral);
            this.Controls.Add(this.treItems);
            this.Menu = this.mainMenu1;
            this.Name = "frmMain";
            this.Text = "Item Editor";
            this.Closing += new System.ComponentModel.CancelEventHandler(this.frmMain_Closing);
            this.Load += new System.EventHandler(this.frmMain_Load);
            this.pnlChassis.ResumeLayout(false);
            this.tabControl1.ResumeLayout(false);
            this.tbpNormal.ResumeLayout(false);
            this.tbpNormal.PerformLayout();
            this.tbpAdvanced.ResumeLayout(false);
            this.tbpAdvanced.PerformLayout();
            this.tbpExpert.ResumeLayout(false);
            this.tbpExpert.PerformLayout();
            this.pnlModule.ResumeLayout(false);
            this.tabControl2.ResumeLayout(false);
            this.tabPage1.ResumeLayout(false);
            this.tabPage2.ResumeLayout(false);
            this.tabPage3.ResumeLayout(false);
            this.pnlGeneral.ResumeLayout(false);
            this.pnlGeneral.PerformLayout();
            this.pnlGraphic.ResumeLayout(false);
            this.pnlGraphic.PerformLayout();
            ((System.ComponentModel.ISupportInitialize)(this.picChassis)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new frmMain());
		}

		#endregion

		private void frmMain_Load(object sender, System.EventArgs e)
        {
            tmrLoadGOB_Tick(null, null);
		}
		private void frmMain_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			//This triggers a screen to row save
			treItems.SelectedNode = treItems.Nodes[0];
			m_oGobFile.SaveGobFile();
		}
        private void tmrLoadGOB_Tick(object sender, EventArgs e)
        {
            //tmrLoadGOB.Enabled = false;

            DSSortedList oList = null;
            DSGobTable oLoopTable = null;
            TreeNode oNode = null;
            string sFileName = string.Empty;


            if (System.Diagnostics.Debugger.IsAttached == true)
            {
                sFileName = DSMisc.GetDevelopmentAppPath() + @"..\StellarLanes.gob";
            }
            else
            {
                sFileName = DSMisc.GetDevelopmentAppPath() + @"StellarLanes.gob";
            }
            m_oGobFile.LoadGobFile(sFileName, GobConstants.m_cGOBNAME);

            //Setup our tree structure
            m_oChassisNode = treItems.Nodes.Add("Chassis");
            m_oNewChassisNode = m_oChassisNode.Nodes.Add("<Add New>");
            m_oModuleNode = treItems.Nodes.Add("Module");
            m_oNewModuleNode = m_oModuleNode.Nodes.Add("<Add New>");

            //Load the textures
            oList = m_oGobFile.GetTables(enumTableType.Graphic);
            for (int i = 0; i < oList.Count; i++)
            {
                oLoopTable = (DSGobTable)oList.GetByIndex(i);
                cboTextureKey.Items.Add(oLoopTable.TableName);
            }
            oList = m_oGobFile.GetTables(enumTableType.SpriteSheet);
            for (int i = 0; i < oList.Count; i++)
            {
                oLoopTable = (DSGobTable)oList.GetByIndex(i);
                for (int nRow = 0; nRow < oLoopTable.RowCount; nRow++)
                {
                    cboTextureKey.Items.Add((string)oLoopTable.GetData(0, nRow));
                }
            }

            //Ok we've loaded our GOB, load our tree with chassis			
            m_oChassisTable = (DSGobTable)m_oGobFile.Tables[GobConstants.m_cTABLE_CHASSIS];
            for (int i = 0; i < m_oChassisTable.RowCount; i++)
            {
                sFileName = DSMisc.TypeUtils.GetSafeStr(m_oChassisTable.GetData("Name_Nrm", i));
                oNode = m_oChassisNode.Nodes.Add(sFileName);
                oNode.Tag = i;
            }

            //Ok we've loaded our GOB, load our tree with modules			
            m_oModuleTable = (DSGobTable)m_oGobFile.Tables[GobConstants.m_cTABLE_MODULE];
            for (int i = 0; i < m_oModuleTable.RowCount; i++)
            {
                sFileName = DSMisc.TypeUtils.GetSafeStr(m_oModuleTable.GetData("Name_Nrm", i));
                oNode = m_oModuleNode.Nodes.Add(sFileName);
                oNode.Tag = i;
            }


            treItems.ExpandAll();

        }

		private void treItems_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
			TreeNode oNode = null;
			int nNewIndex = 0;
			string sName = string.Empty;


			pnlChassis.Visible = false;
			pnlModule.Visible = false;
			pnlGeneral.Visible = false;

			//New node selected
			if( e.Node == m_oNewChassisNode )
			{
				ClearChassis();

				nNewIndex = m_oChassisTable.RowCount;
				sName = "New Chassis " + nNewIndex.ToString();

				m_oChassisTable.AddRow();				
				m_oChassisTable.SetData( "GenericChassisID", nNewIndex, nNewIndex );
				m_oChassisTable.SetData( "Name_Nrm", nNewIndex, sName );

				oNode = m_oChassisNode.Nodes.Add( sName );
				oNode.Tag = nNewIndex;

				treItems.SelectedNode = oNode;				
			}
			else if( e.Node == m_oNewModuleNode )
			{
				ClearModule();

				nNewIndex = m_oModuleTable.RowCount;
				sName = "New Module " + nNewIndex.ToString();

				m_oModuleTable.AddRow();				
				m_oModuleTable.SetData( "GenericModuleID", nNewIndex, nNewIndex );
				m_oModuleTable.SetData( "Name_Nrm", nNewIndex, sName );

				oNode = m_oModuleNode.Nodes.Add( sName );
				oNode.Tag = nNewIndex;

				treItems.SelectedNode = oNode;		
			}
			else if( e.Node.Parent == m_oChassisNode )
			{
				ChassisRowToScr( (int)e.Node.Tag );
				pnlChassis.Visible = true;
				pnlGeneral.Visible = true;
				lblTextureKey.Visible = true;
				cboTextureKey.Visible = true;
			}
			else if( e.Node.Parent == m_oModuleNode )
			{
				ModuleRowToScr( (int)e.Node.Tag );
				pnlModule.Visible = true;
				pnlGeneral.Visible = true;
				lblTextureKey.Visible = true;
				cboTextureKey.Visible = true;
			}
		}
		private void treItems_BeforeSelect(object sender, System.Windows.Forms.TreeViewCancelEventArgs e)
		{
			if( treItems.SelectedNode != null && treItems.SelectedNode.Tag != null )
			{
				if( treItems.SelectedNode.Parent == m_oChassisNode )
				{
					ChassisScrToRow( (int)treItems.SelectedNode.Tag );
				}
				else if( treItems.SelectedNode.Parent == m_oModuleNode )
				{
					ModuleScrToRow( (int)treItems.SelectedNode.Tag );
				}
			}
		}

		#region Chassis Functionality
		private void ClearChassis()
		{
			cboTextureKey.Text		= "";
			chkShowInSpace.Checked	= true;
			txtWidth.Text			= "1";
			txtHeight.Text			= "1";
			m_sCurrentModuleTypes	= string.Empty;

			//Normal
			txtChassis_Normal_Name.Text			= "";
			txtChassis_Normal_Structure.Text	= "1";
			txtChassis_Normal_Mass.Text			= "1.0";
			txtChassis_Normal_FixedRedux.Text	= "0";
			txtChassis_Normal_PercRedux.Text	= "0";
			//Advanced
			txtChassis_Advanced_Name.Text		= "";
			txtChassis_Advanced_Structure.Text	= "1";
			txtChassis_Advanced_Mass.Text		= "1.0";
			txtChassis_Advanced_FixedRedux.Text	= "0";
			txtChassis_Advanced_PercRedux.Text	= "0";
			//Expert
			txtChassis_Expert_Name.Text			= "";
			txtChassis_Expert_Structure.Text	= "1";
			txtChassis_Expert_Mass.Text			= "1.0";
			txtChassis_Expert_FixedRedux.Text	= "0";
			txtChassis_Expert_PercRedux.Text	= "0";


			////////////////////////////////////////////////////////////
			//Module
			txtWidth.Text		= "1";
			txtHeight.Text	= "1";

			//Normal
			ctlModuleProperties_Nrm.Clear();
			//Advanced
			ctlModuleProperties_Adv.Clear();
			//Expert
			ctlModuleProperties_Exp.Clear();
		}

		private void ChassisRowToScr( int nRow )
		{
			chkShowInSpace.Checked = true;
			chkShowInSpace.Enabled = false;

			cboTextureKey.Text		= DSMisc.TypeUtils.GetSafeStr( m_oChassisTable.GetData( "Texture",nRow ) );
			txtWidth.Text			= DSMisc.TypeUtils.GetSafeLng( m_oChassisTable.GetData( "Width",nRow ) ).ToString();
			txtHeight.Text			= DSMisc.TypeUtils.GetSafeLng( m_oChassisTable.GetData( "Height",nRow ) ).ToString();
			m_sCurrentModuleTypes	= DSMisc.TypeUtils.GetSafeStr( m_oChassisTable.GetData( "ModuleType",nRow ) );

			//Normal
			txtChassis_Normal_MinLevel.Text		= DSMisc.TypeUtils.GetSafeLng( m_oChassisTable.GetData( "MinLevel_Nrm",nRow ) ).ToString();
			txtChassis_Normal_Name.Text			= DSMisc.TypeUtils.GetSafeStr( m_oChassisTable.GetData( "Name_Nrm",nRow ) );
			txtChassis_Normal_Structure.Text	= DSMisc.TypeUtils.GetSafeLng( m_oChassisTable.GetData( "StructurePoints_Nrm",nRow ) ).ToString();
			txtChassis_Normal_Mass.Text			= DSMisc.TypeUtils.GetSafeDbl( m_oChassisTable.GetData( "Mass_Nrm",nRow ) ).ToString();
			txtChassis_Normal_FixedRedux.Text	= DSMisc.TypeUtils.GetSafeLng( m_oChassisTable.GetData( "FixedDamageRedux_Nrm",nRow ) ).ToString();
			txtChassis_Normal_PercRedux.Text	= DSMisc.TypeUtils.GetSafeDbl( m_oChassisTable.GetData( "PercentDamageRedux_Nrm",nRow ) ).ToString();
			//Advanced
			txtChassis_Advanced_MinLevel.Text	= DSMisc.TypeUtils.GetSafeLng( m_oChassisTable.GetData( "MinLevel_Adv",nRow ) ).ToString();
			txtChassis_Advanced_Name.Text		= DSMisc.TypeUtils.GetSafeStr( m_oChassisTable.GetData( "Name_Adv",nRow ) );
			txtChassis_Advanced_Structure.Text	= DSMisc.TypeUtils.GetSafeLng( m_oChassisTable.GetData( "StructurePoints_Adv",nRow ) ).ToString();
			txtChassis_Advanced_Mass.Text		= DSMisc.TypeUtils.GetSafeDbl( m_oChassisTable.GetData( "Mass_Adv",nRow ) ).ToString();
			txtChassis_Advanced_FixedRedux.Text	= DSMisc.TypeUtils.GetSafeLng( m_oChassisTable.GetData( "FixedDamageRedux_Adv",nRow ) ).ToString();
			txtChassis_Advanced_PercRedux.Text	= DSMisc.TypeUtils.GetSafeDbl( m_oChassisTable.GetData( "PercentDamageRedux_Adv",nRow ) ).ToString();
			//Expert
			txtChassis_Expert_MinLevel.Text		= DSMisc.TypeUtils.GetSafeLng( m_oChassisTable.GetData( "MinLevel_Exp",nRow ) ).ToString();
			txtChassis_Expert_Name.Text			= DSMisc.TypeUtils.GetSafeStr( m_oChassisTable.GetData( "Name_Exp",nRow ) );
			txtChassis_Expert_Structure.Text	= DSMisc.TypeUtils.GetSafeLng( m_oChassisTable.GetData( "StructurePoints_Exp",nRow ) ).ToString();
			txtChassis_Expert_Mass.Text			= DSMisc.TypeUtils.GetSafeDbl( m_oChassisTable.GetData( "Mass_Exp",nRow ) ).ToString();
			txtChassis_Expert_FixedRedux.Text	= DSMisc.TypeUtils.GetSafeLng( m_oChassisTable.GetData( "FixedDamageRedux_Exp",nRow ) ).ToString();
			txtChassis_Expert_PercRedux.Text	= DSMisc.TypeUtils.GetSafeDbl( m_oChassisTable.GetData( "PercentDamageRedux_Exp",nRow ) ).ToString();


			SetupGraphicDisplay( cboTextureKey.Text );
		}
		private void ChassisScrToRow( int nRow )
		{
			m_oChassisTable.SetData( "Texture",				nRow,cboTextureKey.Text );
			SetLngDataToChassisRow( txtWidth.Text,			nRow,"Width" );
			SetLngDataToChassisRow( txtHeight.Text,			nRow,"Height" );
			m_oChassisTable.SetData( "ModuleType",			nRow,m_sCurrentModuleTypes );

			//Normal
			SetLngDataToChassisRow( txtChassis_Normal_MinLevel.Text,	nRow,"MinLevel_Nrm" );
			m_oChassisTable.SetData( "Name_Nrm",nRow,txtChassis_Normal_Name.Text );
			SetLngDataToChassisRow( txtChassis_Normal_Structure.Text,	nRow,"StructurePoints_Nrm" );
			SetDblDataToChassisRow( txtChassis_Normal_Mass.Text,		nRow,"Mass_Nrm" );
			SetLngDataToChassisRow( txtChassis_Normal_FixedRedux.Text,	nRow,"FixedDamageRedux_Nrm" );
			SetDblDataToChassisRow( txtChassis_Normal_PercRedux.Text,	nRow,"PercentDamageRedux_Nrm" );
			//Advanced
			SetLngDataToChassisRow( txtChassis_Advanced_MinLevel.Text,		nRow,"MinLevel_Adv" );
			m_oChassisTable.SetData( "Name_Adv",nRow,txtChassis_Advanced_Name.Text );
			SetLngDataToChassisRow( txtChassis_Advanced_Structure.Text,		nRow,"StructurePoints_Adv" );
			SetDblDataToChassisRow( txtChassis_Advanced_Mass.Text,			nRow,"Mass_Adv" );
			SetLngDataToChassisRow( txtChassis_Advanced_FixedRedux.Text,	nRow,"FixedDamageRedux_Adv" );
			SetDblDataToChassisRow( txtChassis_Advanced_PercRedux.Text,		nRow,"PercentDamageRedux_Adv" );
			//Expert
			SetLngDataToChassisRow( txtChassis_Expert_MinLevel.Text,	nRow,"MinLevel_Exp" );
			m_oChassisTable.SetData( "Name_Exp",nRow,txtChassis_Expert_Name.Text );
			SetLngDataToChassisRow( txtChassis_Expert_Structure.Text,	nRow,"StructurePoints_Exp" );
			SetDblDataToChassisRow( txtChassis_Expert_Mass.Text,		nRow,"Mass_Exp" );
			SetLngDataToChassisRow( txtChassis_Expert_FixedRedux.Text,	nRow,"FixedDamageRedux_Exp" );
			SetDblDataToChassisRow( txtChassis_Expert_PercRedux.Text,	nRow,"PercentDamageRedux_Exp" );
		}
		private void SetLngDataToChassisRow( string sValue,int nRow,string sTableColumnName )
		{
			if( DSMisc.IsNumericLong( sValue ) == true )
			{
				m_oChassisTable.SetData( sTableColumnName	,nRow,Convert.ToInt64( sValue ) );
			}
			else
			{
				m_oChassisTable.SetData( sTableColumnName	,nRow,0 );
			}		
		}
		private void SetDblDataToChassisRow( string sValue,int nRow,string sTableColumnName )
		{
			if( DSMisc.IsNumericDouble( sValue ) == true )
			{
				m_oChassisTable.SetData( sTableColumnName,nRow,Convert.ToDouble( sValue ) );
			}
			else
			{
				m_oChassisTable.SetData( sTableColumnName,nRow,0.0 );
			}	
		}


		private void txtChassis_Normal_Name_TextChanged(object sender, System.EventArgs e)
		{
			treItems.SelectedNode.Text = txtChassis_Normal_Name.Text;
		}

		private void txtChassisSize_TextChanged(object sender, System.EventArgs e)
		{
			SetupGraphicDisplay( cboTextureKey.Text );
		}

		#endregion
		#region Module Functionality 
		private void ClearModule()
		{
			cboTextureKey.Text	= "";
			txtWidth.Text		= "1";
			txtHeight.Text		= "1";

			//Normal
			ctlModuleProperties_Nrm.Clear();
			//Advanced
			ctlModuleProperties_Adv.Clear();
			//Expert
			ctlModuleProperties_Exp.Clear();
		}

		private void ModuleRowToScr( int nRow )
		{
			chkShowInSpace.Enabled = true;

			cboTextureKey.Text		= DSMisc.TypeUtils.GetSafeStr( m_oModuleTable.GetData( "Texture",nRow ) );
			chkShowInSpace.Checked	= DSMisc.TypeUtils.GetSafeBool( m_oModuleTable.GetData( "ShowTextureInSpace",nRow ) );			
			txtWidth.Text			= DSMisc.TypeUtils.GetSafeLng( m_oModuleTable.GetData( "Width",nRow ) ).ToString();
			txtHeight.Text			= DSMisc.TypeUtils.GetSafeLng( m_oModuleTable.GetData( "Height",nRow ) ).ToString();
			m_sCurrentModuleTypes	= DSMisc.TypeUtils.GetSafeStr( m_oModuleTable.GetData( "ModuleType",nRow ) );

			CopyModulePropertiesToControl( ctlModuleProperties_Nrm,nRow,"_Nrm",0 );
			CopyModulePropertiesToControl( ctlModuleProperties_Adv,nRow,"_Adv",1 );
			CopyModulePropertiesToControl( ctlModuleProperties_Exp,nRow,"_Exp",2 );

			SetupGraphicDisplay( cboTextureKey.Text );
		}
		private void ModuleScrToRow( int nRow )
		{
			treItems.SelectedNode.Text = ctlModuleProperties_Nrm.ModuleName;

			m_oModuleTable.SetData( "Texture",				nRow,cboTextureKey.Text );
			m_oModuleTable.SetData( "ShowTextureInSpace",	nRow,chkShowInSpace.Checked );
			SetLngDataToModuleRow( txtWidth.Text,			nRow,"Width" );
			SetLngDataToModuleRow( txtHeight.Text,			nRow,"Height" );
			m_oModuleTable.SetData( "ModuleType",			nRow,m_sCurrentModuleTypes );

			CopyModulePropertiesFromControl( ctlModuleProperties_Nrm,nRow,"_Nrm",0 );
			CopyModulePropertiesFromControl( ctlModuleProperties_Adv,nRow,"_Adv",1 );
			CopyModulePropertiesFromControl( ctlModuleProperties_Exp,nRow,"_Exp",2 );
		}
		private void CopyModulePropertiesToControl( ctlModuleProperties oControl,int nRow,string sDiff,int nDiffPart )
		{
			oControl.ModuleName				= m_oModuleTable.GetData( "Name" + sDiff,nRow ).ToString();
			oControl.MinLevel				= DSMisc.TypeUtils.GetSafeLng( m_oModuleTable.GetData( "MinLevel" + sDiff,nRow ) );

			oControl.StoresEnergy			= DSMisc.TypeUtils.GetSafeBool( m_oModuleTable.GetData( "StoreEnergy" + sDiff,nRow ) );
			oControl.Battery_Min			= DSMisc.TypeUtils.GetSafeDbl( m_oModuleTable.GetData( "StoreEnergy_Min" + sDiff,nRow ) );
			oControl.Battery_Max			= DSMisc.TypeUtils.GetSafeDbl( m_oModuleTable.GetData( "StoreEnergy_Max" + sDiff,nRow ) );
			oControl.BatteryAbsorb_Min		= DSMisc.TypeUtils.GetSafeDbl( m_oModuleTable.GetData( "StoreEnergyAbsorb_Min" + sDiff,nRow ) );
			oControl.BatteryAbsorb_Max		= DSMisc.TypeUtils.GetSafeDbl( m_oModuleTable.GetData( "StoreEnergyAbsorb_Max" + sDiff,nRow ) );
			oControl.BatteryRelease_Min		= DSMisc.TypeUtils.GetSafeDbl( m_oModuleTable.GetData( "StoreEnergyRelease_Min" + sDiff,nRow ) );
			oControl.BatteryRelease_Max		= DSMisc.TypeUtils.GetSafeDbl( m_oModuleTable.GetData( "StoreEnergyRelease_Max" + sDiff,nRow ) );

			oControl.GeneratesEnergy		= DSMisc.TypeUtils.GetSafeBool( m_oModuleTable.GetData( "GenerateEnergy" + sDiff,nRow ) );
			oControl.Generate_Min			= DSMisc.TypeUtils.GetSafeDbl( m_oModuleTable.GetData( "GenerateEnergy_Min" + sDiff,nRow ) );
			oControl.Generate_Max			= DSMisc.TypeUtils.GetSafeDbl( m_oModuleTable.GetData( "GenerateEnergy_Max" + sDiff,nRow ) );

			oControl.ConsumesEnergy			= GetBoolPartFromModule( "ConsumeEnergy",nRow,nDiffPart );
			oControl.Consume_Min			= GetDblPartFromModule( "ConsumeEnergy_Min",nRow,nDiffPart );
			oControl.Consume_Max			= GetDblPartFromModule( "ConsumeEnergy_Max",nRow,nDiffPart );

			oControl.AttitudeThruster 		= DSMisc.TypeUtils.GetSafeBool( m_oModuleTable.GetData( "TurningThrust" + sDiff,nRow ) );
			oControl.TurningThrust_Min		= DSMisc.TypeUtils.GetSafeDbl( m_oModuleTable.GetData( "TurningThrust_Min" + sDiff,nRow ) );
			oControl.TurningThrust_Max 		= DSMisc.TypeUtils.GetSafeDbl( m_oModuleTable.GetData( "TurningThrust_Max" + sDiff,nRow ) );

			oControl.LinearThruster 		= DSMisc.TypeUtils.GetSafeBool( m_oModuleTable.GetData( "LinearThruster" + sDiff,nRow ) );
			oControl.LinearThrust_Min 		= DSMisc.TypeUtils.GetSafeDbl( m_oModuleTable.GetData( "LinearThrust_Min" + sDiff,nRow ) );
			oControl.LinearThrust_Max 		= DSMisc.TypeUtils.GetSafeDbl( m_oModuleTable.GetData( "LinearThrust_Max" + sDiff,nRow ) );
			oControl.LinearThrust_PSys 		= DSMisc.TypeUtils.GetSafeLng( m_oModuleTable.GetData( "LinearThrust_PSystem" + sDiff,nRow ) );
			oControl.LinearBreakThrust_Min	= DSMisc.TypeUtils.GetSafeDbl( m_oModuleTable.GetData( "LinearBreakThrust_Min" + sDiff,nRow ) );
			oControl.LinearBreakThrust_Max	= DSMisc.TypeUtils.GetSafeDbl( m_oModuleTable.GetData( "LinearBreakThrust_Max" + sDiff,nRow ) );

			oControl.HUDLevel				= DSMisc.TypeUtils.GetSafeInt( m_oModuleTable.GetData( "HUDLevel" + sDiff,nRow ) );
			oControl.GeneratesHUDLevel 		= ( oControl.HUDLevel > 0 );
		}
		private void CopyModulePropertiesFromControl( ctlModuleProperties oControl,int nRow,string sDiff,int nDiffPart )
		{
			m_oModuleTable.SetData( "Name" + sDiff,nRow,oControl.ModuleName );
			SetLngDataToModuleRow( oControl.MinLevel.ToString(),nRow,"MinLevel" + sDiff );

			m_oModuleTable.SetData( "StoreEnergy" + sDiff,nRow,oControl.StoresEnergy );
			SetDblDataToModuleRow( oControl.Battery_Min.ToString(),				nRow,"StoreEnergy_Min" + sDiff );
			SetDblDataToModuleRow( oControl.Battery_Max.ToString(),				nRow,"StoreEnergy_Max" + sDiff );
			SetDblDataToModuleRow( oControl.BatteryAbsorb_Min.ToString(),		nRow,"StoreEnergyAbsorb_Min" + sDiff );
			SetDblDataToModuleRow( oControl.BatteryAbsorb_Max.ToString(),		nRow,"StoreEnergyAbsorb_Max" + sDiff );
			SetDblDataToModuleRow( oControl.BatteryRelease_Min.ToString(),		nRow,"StoreEnergyRelease_Min" + sDiff );
			SetDblDataToModuleRow( oControl.BatteryRelease_Max.ToString(),		nRow,"StoreEnergyRelease_Max" + sDiff );

			m_oModuleTable.SetData( "GenerateEnergy" + sDiff,nRow,oControl.GeneratesEnergy );
			SetDblDataToModuleRow( oControl.Generate_Min.ToString(),			nRow,"GenerateEnergy_Min" + sDiff );
			SetDblDataToModuleRow( oControl.Generate_Max.ToString(),			nRow,"GenerateEnergy_Max" + sDiff );

			SetValuePartToModule("ConsumeEnergy",		nRow,nDiffPart,oControl.ConsumesEnergy.ToString() );
			SetValuePartToModule("ConsumeEnergy_Min",	nRow,nDiffPart,oControl.Consume_Min.ToString() );
			SetValuePartToModule("ConsumeEnergy_Max",	nRow,nDiffPart,oControl.Consume_Max.ToString() );

			m_oModuleTable.SetData( "TurningThrust" + sDiff,nRow,oControl.AttitudeThruster );
			SetDblDataToModuleRow( oControl.TurningThrust_Min.ToString(),		nRow,"TurningThrust_Min" + sDiff );
			SetDblDataToModuleRow( oControl.TurningThrust_Max.ToString(),		nRow,"TurningThrust_Max" + sDiff );

			m_oModuleTable.SetData( "LinearThruster" + sDiff,nRow,oControl.LinearThruster );
			SetDblDataToModuleRow( oControl.LinearThrust_Min.ToString(),		nRow,"LinearThrust_Min" + sDiff );
			SetDblDataToModuleRow( oControl.LinearThrust_Max.ToString(),		nRow,"LinearThrust_Max" + sDiff );
			SetLngDataToModuleRow( oControl.LinearThrust_PSys.ToString(),		nRow,"LinearThrust_PSystem" + sDiff );
			SetDblDataToModuleRow( oControl.LinearBreakThrust_Min.ToString(),	nRow,"LinearBreakThrust_Min" + sDiff );
			SetDblDataToModuleRow( oControl.LinearBreakThrust_Max.ToString(),	nRow,"LinearBreakThrust_Max" + sDiff );

			if( oControl.GeneratesHUDLevel == true )
			{
				SetDblDataToModuleRow( oControl.HUDLevel.ToString(),			nRow,"HUDLevel" + sDiff );
			}
			else
			{
				SetDblDataToModuleRow( "0",										nRow,"HUDLevel" + sDiff );
			}
		}
		//Old System
		private void SetLngDataToModuleRow( string sValue,int nRow,string sTableColumnName )
		{
			if( DSMisc.IsNumericLong( sValue ) == true )
			{
				m_oModuleTable.SetData( sTableColumnName	,nRow,Convert.ToInt64( sValue ) );
			}
			else
			{
				m_oModuleTable.SetData( sTableColumnName	,nRow,0 );
			}		
		}
		private void SetDblDataToModuleRow( string sValue,int nRow,string sTableColumnName )
		{
			if( DSMisc.IsNumericDouble( sValue ) == true )
			{
				m_oModuleTable.SetData( sTableColumnName,nRow,Convert.ToDouble( sValue ) );
			}
			else
			{
				m_oModuleTable.SetData( sTableColumnName,nRow,0.0 );
			}	
		}

		//New System
		private bool GetBoolPartFromModule( string sColumnKey,int nRow,int nPart )
		{
			bool bValue = false;
			string sValue = string.Empty;
			string[] saParts = null;


			sValue = DSMisc.TypeUtils.GetSafeStr( m_oModuleTable.GetData( sColumnKey,nRow ) );
			saParts = DSMisc.Split( sValue,";" );

			if( saParts.Length > nPart )
			{
				bValue = DSMisc.TypeUtils.GetSafeBool( saParts[ nPart ] );
			}
			

			return( bValue );
		}
		private double GetDblPartFromModule( string sColumnKey,int nRow,int nPart )
		{
			double nValue = 0.0;
			string sValue = string.Empty;
			string[] saParts = null;


			sValue = DSMisc.TypeUtils.GetSafeStr( m_oModuleTable.GetData( sColumnKey,nRow ) );
			saParts = DSMisc.Split( sValue,";" );

			if( saParts.Length > nPart )
			{
				nValue = DSMisc.TypeUtils.GetSafeDbl( saParts[ nPart ] );
			}
			

			return( nValue );
		}
		private void SetValuePartToModule( string sColumnKey,int nRow,int nPart,string sValue )
		{
			string sCurrentDBValue = string.Empty;
			string sNewDBValue = string.Empty;
			string[] saParts = null;
			string[] saTempParts = null;


			sCurrentDBValue = DSMisc.TypeUtils.GetSafeStr( m_oModuleTable.GetData( sColumnKey,nRow ) );
			saParts = DSMisc.Split( sCurrentDBValue,";" );

			if( saParts.Length <= nPart )
			{
				saTempParts = new string[ nPart+1 ];
				for( int i=0 ; i<saParts.Length ; i++ )
				{
					saTempParts[ i ] = saParts[ i ];
				}
				saParts = saTempParts;
			}
			saParts[ nPart ] = sValue;

			sNewDBValue = DSMisc.Join( saParts,";" );
			m_oModuleTable.SetData( sColumnKey,nRow,sNewDBValue );
		}
		#endregion

		private void txtPicSize_TextChanged(object sender, System.EventArgs e)
		{
			SetupGraphicDisplay( cboTextureKey.Text );
		}
		private void SetupGraphicDisplay( string sGraphicKey )
		{
			Bitmap oFilePic = null;
			Bitmap oModifiedPic = null;
			System.IO.MemoryStream oStream = null;
			LoadedTexture oLoadedTexture = null;
			System.Drawing.Color oColor = System.Drawing.Color.White;
			int nGridWidth = 0, nGridHeight = 0;
			int nGridX = 0, nGridY = 0;
			int nType = 0;
			int nColorChange = 150;


			try
			{
				oLoadedTexture = DSResourceManager.GetGlobalInstance().GetLoadedTexture( sGraphicKey );
				oStream = (System.IO.MemoryStream)oLoadedTexture.oStream;
				if( oStream != null )
				{
					nGridWidth = (int)( (double)oLoadedTexture.Size.X / 
						(double)DSMisc.TypeUtils.GetSafeDbl( txtWidth.Text ) );
					if( nGridWidth == 0 ){ nGridWidth = (int)oLoadedTexture.Size.X; }
					nGridHeight = (int)( (double)oLoadedTexture.Size.Y / 
						(double)DSMisc.TypeUtils.GetSafeLng( txtHeight.Text ) );
					if( nGridHeight == 0 ){ nGridHeight = (int)oLoadedTexture.Size.Y; }

					oFilePic = new Bitmap( oStream );
					oModifiedPic = new Bitmap( (int)oLoadedTexture.Size.X,(int)oLoadedTexture.Size.Y );
					for( int nX=0 ; nX<oModifiedPic.Width ; nX++ )
					{
						for( int nY=0 ; nY<oModifiedPic.Height ; nY++ )
						{
							//Which square are we in?
							nGridX = (int)Math.Floor( (double)nX / nGridWidth );
                            nGridY = (int)Math.Floor((double)nY / nGridHeight);
							nType = GetModuleType( nGridX,nGridY );

							if( ( nX % nGridWidth ) == 0 || ( nY % nGridHeight ) == 0 )
							{
								oColor = System.Drawing.Color.Red;
							}
							else
							{
								oColor = oFilePic.GetPixel( (int)( oLoadedTexture.m_nRealPicLeft + nX ),
									(int)( oLoadedTexture.m_nRealPicTop + nY ) );

								if( ( nType & (int)enumModuleType.Connector ) == (int)enumModuleType.Connector )
								{
									oColor = ShiftColor( oColor,-nColorChange,-nColorChange,nColorChange );
								}
								else if( ( nType & (int)enumModuleType.CantBeUsed ) == (int)enumModuleType.CantBeUsed )
								{
									oColor = ShiftColor( oColor,nColorChange,-nColorChange,-nColorChange );
								}
								else if( ( nType & (int)enumModuleType.OpenSpace ) == (int)enumModuleType.OpenSpace )
								{
									oColor = ShiftColor( oColor,-nColorChange,-nColorChange,-nColorChange );
								}
							}
							oModifiedPic.SetPixel( nX,nY,oColor );
						}
					}

					//Format our bitmap properly
					oModifiedPic = DSMisc.Graphics.ConvertIndexedToRGBBitMap( oModifiedPic );
				}
			}
			catch//( System.Exception oEx )
			{
				oModifiedPic = null;
			}

			picChassis.Image = oModifiedPic;
		}
		private void picChassis_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			LoadedTexture oLoadedTexture = null;
			System.Drawing.Color oColor = System.Drawing.Color.White;
			int nGridWidth = 0, nGridHeight = 0;
			int nGridX = 0, nGridY = 0;
			int nModuleType = 0;


			if( DSResourceManager.GetGlobalInstance().IsTextureLoaded( cboTextureKey.Text ) == true )
			{
				oLoadedTexture = DSResourceManager.GetGlobalInstance().GetLoadedTexture( cboTextureKey.Text );

				//Find the grid sizes
				nGridWidth = (int)( (double)oLoadedTexture.Size.X / 
					(double)DSMisc.TypeUtils.GetSafeDbl( txtWidth.Text ) );
				if( nGridWidth == 0 ){ nGridWidth = (int)oLoadedTexture.Size.X; }
				nGridHeight = (int)( (double)oLoadedTexture.Size.Y / 
					(double)DSMisc.TypeUtils.GetSafeLng( txtHeight.Text ) );
				if( nGridHeight == 0 ){ nGridHeight = (int)oLoadedTexture.Size.Y; }
		
				//Which square was clicked?
                nGridX = (int)Math.Floor((double)e.X / nGridWidth);
                nGridY = (int)Math.Floor((double)e.Y / nGridHeight);

				if( e.Button == System.Windows.Forms.MouseButtons.Left )
				{
					nModuleType = GetModuleType( nGridX,nGridY );
					frmModuleType oSelectType = new frmModuleType();
					oSelectType.ModuleTypesAllowed = nModuleType;
					oSelectType.ShowDialog();
					nModuleType = oSelectType.ModuleTypesAllowed;
					m_nLastChassisTypeAssigned = nModuleType;
				}
				else
				{
					nModuleType = m_nLastChassisTypeAssigned;
				}
				
				UpdateModuleType( nGridX,nGridY,nModuleType );


				SetupGraphicDisplay( cboTextureKey.Text );
			}
		}
		private void UpdateModuleType( int nX,int nY,int nType )
		{
			string[] saModuleTypes = null;
			string[] saFields = null;
			string sNewModuleTyprStr = string.Empty;
			int nLoopX = 0, nLoopY = 0, nLoopType = 0;
			bool bOurFieldAdded = false;


			saModuleTypes = DSMisc.Split( m_sCurrentModuleTypes,";" );

			for( int i=0 ; i<saModuleTypes.Length ; i++ )
			{
				saFields = DSMisc.Split( saModuleTypes[i],"," );
				if( saFields.Length == 3 )
				{
					nLoopX		= DSMisc.TypeUtils.GetSafeInt( saFields[0] );
					nLoopY		= DSMisc.TypeUtils.GetSafeInt( saFields[1] );
					nLoopType	= DSMisc.TypeUtils.GetSafeInt( saFields[2] );

					if( nLoopX == nX && nLoopY == nY )
					{
						bOurFieldAdded = true;

						if( nType == 0 )
						{
							//Remove this entry
						}
						else
						{
							sNewModuleTyprStr += nLoopX.ToString() + "," + nLoopY.ToString() + "," + 
								nType.ToString() + ";"; 
						}
					}
					else if( nLoopX < DSMisc.TypeUtils.GetSafeLng( txtWidth.Text ) &&
						nLoopY < DSMisc.TypeUtils.GetSafeLng( txtHeight.Text ) )
					{
						sNewModuleTyprStr += nLoopX.ToString() + "," + nLoopY.ToString() + "," + 
							nLoopType.ToString() + ";"; 
					}
				}
			}

			if( bOurFieldAdded == false && nType > 0 )
			{
				sNewModuleTyprStr += nX.ToString() + "," + nY.ToString() + "," + nType.ToString() + ";";
			}

			m_sCurrentModuleTypes = sNewModuleTyprStr;
		}
		private int GetModuleType( int nX,int nY )
		{
			string[] saModuleTypes = null;
			string[] saFields = null;
			int nLoopX = 0, nLoopY = 0, nLoopType = 0;
			int nModuleType = 0;


			saModuleTypes = DSMisc.Split( m_sCurrentModuleTypes,";" );

			for( int i=0 ; i<saModuleTypes.Length ; i++ )
			{
				saFields = DSMisc.Split( saModuleTypes[i],"," );

				if( saFields.Length == 3 )
				{
					nLoopX		= DSMisc.TypeUtils.GetSafeInt( saFields[0] );
					nLoopY		= DSMisc.TypeUtils.GetSafeInt( saFields[1] );
					nLoopType	= DSMisc.TypeUtils.GetSafeInt( saFields[2] );

					if( nLoopX == nX && nLoopY == nY )
					{
						nModuleType = nLoopType;
					}
				}
			}

			
			return( nModuleType );
		}
		private System.Drawing.Color ShiftColor( System.Drawing.Color oStartingColor,int nRedChange,int nGreenChange, int nBlueChange )
		{
			System.Drawing.Color oColor = System.Drawing.Color.FromArgb( 
								DSMisc.Max( 0, DSMisc.Min( 255,oStartingColor.R + nRedChange ) ),
								DSMisc.Max( 0, DSMisc.Min( 255,oStartingColor.G + nGreenChange ) ),
								DSMisc.Max( 0, DSMisc.Min( 255,oStartingColor.B + nBlueChange ) ) );

			return( oColor );
		}

		private void cboTextureKey_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			SetupGraphicDisplay( cboTextureKey.Text );
		}

		private void mnuFile_Save_Click(object sender, System.EventArgs e)
		{
			//This triggers a screen to row save
			treItems.SelectedNode = treItems.Nodes[0];
			m_oGobFile.SaveGobFile();		
		}
		private void mnuFile_Exit_Click(object sender, System.EventArgs e)
		{
			this.Close();		
		}
	}
}
